#include <stdio.h>
#include <geodata_private.h>
#include "types.h"
char *GB_get_label();

void GB_recur_write_data_desc(f,obj,label,indent)
  FILE *f;
  GD_data_desc *obj;
   char *label;
   int indent;
{
 char *o_ptr;
  int i;

        if(label!=NULL) GB_write_data_desc(f,obj,label,indent);
} /* GB_recur_write_data_desc */

void GB_recur_write_vertex(f,obj,label,indent)
  FILE *f;
  GS_vertex *obj;
   char *label;
   int indent;
{
 char *o_ptr;
  int i;

        if(label!=NULL) GB_write_vertex(f,obj,label,indent);
} /* GB_recur_write_vertex */

void GB_recur_write_polygon(f,obj,label,indent)
  FILE *f;
  GS_polygon *obj;
   char *label;
   int indent;
{
 char *o_ptr;
  int i;

  if(obj->vertices!=0){
     for(o_ptr = (char *)obj->vertices; o_ptr != NULL;
         o_ptr = (char *)(((struct GS_vertex *)o_ptr)->next))
         GB_recur_write_vertex(f,o_ptr,'\0',indent+7);
  }
        if(label!=NULL) GB_write_polygon(f,obj,label,indent);
} /* GB_recur_write_polygon */

void GB_recur_write_symbol(f,obj,label,indent)
  FILE *f;
  GS_symbol *obj;
   char *label;
   int indent;
{
 char *o_ptr;
  int i;

  if(obj->polygons!=0){
     for(o_ptr = (char *)obj->polygons; o_ptr != NULL;
         o_ptr = (char *)(((struct GS_polygon *)o_ptr)->next))
         GB_recur_write_polygon(f,o_ptr,'\0',indent+7);
  }
        if(label!=NULL) GB_write_symbol(f,obj,label,indent);
} /* GB_recur_write_symbol */

void GB_recur_write_table(f,obj,label,indent)
  FILE *f;
  GS_table *obj;
   char *label;
   int indent;
{
 char *o_ptr;
  int i;

        if(obj->discrete!=0)GB_recur_describe_object(obj->discrete,f,0);
        if(label!=NULL) GB_write_table(f,obj,label,indent);
} /* GB_recur_write_table */

void GB_recur_write_line_style(f,obj,label,indent)
  FILE *f;
  GS_line_style *obj;
   char *label;
   int indent;
{
 char *o_ptr;
  int i;

        if(label!=NULL) GB_write_line_style(f,obj,label,indent);
} /* GB_recur_write_line_style */

void GB_recur_write_representation(f,obj,label,indent)
  FILE *f;
  GS_representation *obj;
   char *label;
   int indent;
{
 char *o_ptr;
  int i;

  if(obj->tables!=0){
     for(o_ptr = (char *)obj->tables; o_ptr != NULL;
         o_ptr = (char *)(((struct GS_table *)o_ptr)->next))
         GB_recur_write_table(f,o_ptr,'\0',indent+7);
  }
        if(label!=NULL) GB_write_representation(f,obj,label,indent);
} /* GB_recur_write_representation */

void GB_recur_write_rep_list(f,obj,label,indent)
  FILE *f;
  GS_rep_list *obj;
   char *label;
   int indent;
{
 char *o_ptr;
  int i;

        if(obj->rep_id!=0)GB_recur_describe_object(obj->rep_id,f,0);
        if(obj->data_id!=0)GB_recur_describe_object(obj->data_id,f,0);
        if(label!=NULL) GB_write_rep_list(f,obj,label,indent);
} /* GB_recur_write_rep_list */

void GB_recur_write_display_scene_list(f,obj,label,indent)
  FILE *f;
  GS_display_scene_list *obj;
   char *label;
   int indent;
{
 char *o_ptr;
  int i;

        if(obj->scene_id!=0)GB_recur_describe_object(obj->scene_id,f,0);
        if(label!=NULL) GB_write_display_scene_list(f,obj,label,indent);
} /* GB_recur_write_display_scene_list */

void GB_recur_write_display(f,obj,label,indent)
  FILE *f;
  GS_display *obj;
   char *label;
   int indent;
{
 char *o_ptr;
  int i;

  if(obj->scenes!=0){
     for(o_ptr = (char *)obj->scenes; o_ptr != NULL;
         o_ptr = (char *)(((struct GS_display_scene_list *)o_ptr)->next))
         GB_recur_write_display_scene_list(f,o_ptr,'\0',indent+7);
  }
        if(label!=NULL) GB_write_display(f,obj,label,indent);
} /* GB_recur_write_display */

void GB_recur_write_scene(f,obj,label,indent)
  FILE *f;
  GS_scene *obj;
   char *label;
   int indent;
{
 char *o_ptr;
  int i;

  if(obj->representations!=0){
     for(o_ptr = (char *)obj->representations; o_ptr != NULL;
         o_ptr = (char *)(((struct GS_rep_list *)o_ptr)->next))
         GB_recur_write_rep_list(f,o_ptr,'\0',indent+7);
  }
        if(label!=NULL) GB_write_scene(f,obj,label,indent);
} /* GB_recur_write_scene */

void GB_recur_write_movie(f,obj,label,indent)
  FILE *f;
  GS_movie *obj;
   char *label;
   int indent;
{
 char *o_ptr;
  int i;

        if(label!=NULL) GB_write_movie(f,obj,label,indent);
} /* GB_recur_write_movie */

void GB_recur_write_video(f,obj,label,indent)
  FILE *f;
  GS_video *obj;
   char *label;
   int indent;
{
 char *o_ptr;
  int i;

        if(label!=NULL) GB_write_video(f,obj,label,indent);
} /* GB_recur_write_video */

void GB_recur_write_include(f,obj,label,indent)
  FILE *f;
  GB_include *obj;
   char *label;
   int indent;
{
 char *o_ptr;
  int i;

        if(label!=NULL) GB_write_include(f,obj,label,indent);
} /* GB_recur_write_include */

void GB_recur_write_update_scene(f,obj,label,indent)
  FILE *f;
  GB_update_scene *obj;
   char *label;
   int indent;
{
 char *o_ptr;
  int i;

        if(obj->scene_id!=0)GB_recur_describe_object(obj->scene_id,f,0);
        if(label!=NULL) GB_write_update_scene(f,obj,label,indent);
} /* GB_recur_write_update_scene */

void GB_recur_write_display_scene(f,obj,label,indent)
  FILE *f;
  GB_display_scene *obj;
   char *label;
   int indent;
{
 char *o_ptr;
  int i;

        if(obj->scene_id!=0)GB_recur_describe_object(obj->scene_id,f,0);
        if(obj->display_id!=0)GB_recur_describe_object(obj->display_id,f,0);
        if(label!=NULL) GB_write_display_scene(f,obj,label,indent);
} /* GB_recur_write_display_scene */

void GB_recur_write_print(f,obj,label,indent)
  FILE *f;
  GB_print *obj;
   char *label;
   int indent;
{
 char *o_ptr;
  int i;

        if(obj->id!=0)GB_recur_describe_object(obj->id,f,0);
        if(label!=NULL) GB_write_print(f,obj,label,indent);
} /* GB_recur_write_print */

void GB_recur_write_recur_print(f,obj,label,indent)
  FILE *f;
  GB_recur_print *obj;
   char *label;
   int indent;
{
 char *o_ptr;
  int i;

        if(obj->obj_id!=0)GB_recur_describe_object(obj->obj_id,f,0);
        if(label!=NULL) GB_write_recur_print(f,obj,label,indent);
} /* GB_recur_write_recur_print */

void GB_recur_write_map_data(f,obj,label,indent)
  FILE *f;
  GB_map_data *obj;
   char *label;
   int indent;
{
 char *o_ptr;
  int i;

        if(obj->from!=0)GB_recur_describe_object(obj->from,f,0);
        if(obj->to!=0)GB_recur_describe_object(obj->to,f,0);
        if(label!=NULL) GB_write_map_data(f,obj,label,indent);
} /* GB_recur_write_map_data */

void GB_recur_write_print_objects(f,obj,label,indent)
  FILE *f;
  GB_print_objects *obj;
   char *label;
   int indent;
{
 char *o_ptr;
  int i;

        if(label!=NULL) GB_write_print_objects(f,obj,label,indent);
} /* GB_recur_write_print_objects */

void GB_recur_write_play_movie(f,obj,label,indent)
  FILE *f;
  GB_play_movie *obj;
   char *label;
   int indent;
{
 char *o_ptr;
  int i;

        if(obj->movie_id!=0)GB_recur_describe_object(obj->movie_id,f,0);
        if(obj->display_id!=0)GB_recur_describe_object(obj->display_id,f,0);
        if(label!=NULL) GB_write_play_movie(f,obj,label,indent);
} /* GB_recur_write_play_movie */

void GB_recur_write_open_video_display(f,obj,label,indent)
  FILE *f;
  GB_open_video_display *obj;
   char *label;
   int indent;
{
 char *o_ptr;
  int i;

        if(label!=NULL) GB_write_open_video_display(f,obj,label,indent);
} /* GB_recur_write_open_video_display */

void GB_recur_write_close_video_display(f,obj,label,indent)
  FILE *f;
  GB_close_video_display *obj;
   char *label;
   int indent;
{
 char *o_ptr;
  int i;

        if(label!=NULL) GB_write_close_video_display(f,obj,label,indent);
} /* GB_recur_write_close_video_display */

void GB_recur_write_play_video(f,obj,label,indent)
  FILE *f;
  GB_play_video *obj;
   char *label;
   int indent;
{
 char *o_ptr;
  int i;

        if(obj->video_id!=0)GB_recur_describe_object(obj->video_id,f,0);
        if(label!=NULL) GB_write_play_video(f,obj,label,indent);
} /* GB_recur_write_play_video */

void GB_recur_write_seek_to_frame(f,obj,label,indent)
  FILE *f;
  GB_seek_to_frame *obj;
   char *label;
   int indent;
{
 char *o_ptr;
  int i;

        if(label!=NULL) GB_write_seek_to_frame(f,obj,label,indent);
} /* GB_recur_write_seek_to_frame */

void GB_recur_write_set_video_switch(f,obj,label,indent)
  FILE *f;
  GB_set_video_switch *obj;
   char *label;
   int indent;
{
 char *o_ptr;
  int i;

        if(label!=NULL) GB_write_set_video_switch(f,obj,label,indent);
} /* GB_recur_write_set_video_switch */

void GB_recur_write_play_pana(f,obj,label,indent)
  FILE *f;
  GB_play_pana *obj;
   char *label;
   int indent;
{
 char *o_ptr;
  int i;

        if(label!=NULL) GB_write_play_pana(f,obj,label,indent);
} /* GB_recur_write_play_pana */

void GB_recur_write_handshake(f,obj,label,indent)
  FILE *f;
  GB_handshake *obj;
   char *label;
   int indent;
{
 char *o_ptr;
  int i;

        if(label!=NULL) GB_write_handshake(f,obj,label,indent);
} /* GB_recur_write_handshake */

void GB_recur_write_sleep(f,obj,label,indent)
  FILE *f;
  GB_sleep *obj;
   char *label;
   int indent;
{
 char *o_ptr;
  int i;

        if(label!=NULL) GB_write_sleep(f,obj,label,indent);
} /* GB_recur_write_sleep */

void GB_recur_write_die(f,obj,label,indent)
  FILE *f;
  GB_die *obj;
   char *label;
   int indent;
{
 char *o_ptr;
  int i;

        if(label!=NULL) GB_write_die(f,obj,label,indent);
} /* GB_recur_write_die */

void GB_recur_write_detach(f,obj,label,indent)
  FILE *f;
  GB_detach *obj;
   char *label;
   int indent;
{
 char *o_ptr;
  int i;

        if(label!=NULL) GB_write_detach(f,obj,label,indent);
} /* GB_recur_write_detach */

void GB_recur_write_xtool_projection(f,obj,label,indent)
  FILE *f;
  GX_xtool_projection *obj;
   char *label;
   int indent;
{
 char *o_ptr;
  int i;

        if(label!=NULL) GB_write_xtool_projection(f,obj,label,indent);
} /* GB_recur_write_xtool_projection */
