#include <math.h>
#include <cm/paris.h>
#include <pgl/pgl.h>
#include <cm/cmfs.h>
#include <cm/cm_file.h>
#include <stdlib.h>
#include <stdio.h>

#define SIZEX 64
#define SIZEY 64
#define SIZEZ 64

shape [SIZEX][SIZEY][SIZEZ]first;

struct point {
  float x,y,z,value;
};


CM_field_id_t load_file (filename,offset)
     char *filename;
     unsigned offset;
{
  int ifd;
  CM_vp_set_id_t entry_vp_set,in;
  CM_field_id_t temp;
  CM_geometry_id_t fg;
  unsigned dimensions[2],rank,i;
  CM_field_id_t dest;

  
  entry_vp_set = CM_current_vp_set;
  if (ifd=CMFS_open(filename,CMFS_O_RDONLY) < 0){
    CMFS_perror ("open failed");
    exit(1);
  }
  fg=(CM_geometry_id_t)CMFS_file_geometry(ifd);
  rank = CM_geometry_rank(fg);
  for (i=0;i<rank;i++) dimensions[i]=CM_geometry_axis_length(fg,i);
  in=CM_allocate_vp_set(CM_create_geometry(dimensions,rank));
  CM_set_vp_set(in);
  dest = CM_allocate_heap_field(32);
  temp = CM_allocate_stack_field(16);
  CMFS_close(ifd);
  if (ifd=CMFS_open(filename,CMFS_O_RDONLY) < 0){
    CMFS_perror ("open failed");
    exit(1);
  }
  CMFS_lseek (ifd,offset*16,CMFS_L_SET);
  if (CMFS_read_file_always(ifd,temp,16) != 16){
    CMFS_perror ("read failed");
    exit(1);
  }
  CM_f_s_float_2_2L (dest,temp,16,23,8);
  CM_deallocate_stack_through(temp);
  CMFS_close(ifd);
  CM_set_vp_set(entry_vp_set);
  return (dest);
}

float:current smooth(float:current in)
{
  float:current temp = in;
  [.-1][.]temp+=in;
  [.+1][.]temp+=in;
  [.][.-1]temp+=in;
  [.][.+1]temp+=in;
  return (temp/5.0);
}


main()
{
  shape terrain_shape;
  float min,max;
  int ifd;
  int i;
  char *filename = "dv:/users/geodata/distribution/demo_terrrain";
  CM_field_id_t out;
  /* temp stuff */
  shape [128][128] small_shape;
 float:small_shape small;
 int:small_shape index_0,index_1;

/* temp stuff */
  with(small_shape) {
    index_0=pcoord(0);
    index_0=index_0 * 8;
    index_1=pcoord(1);
    index_1=index_1 * 8;
  }

  with (first){
  float:void *terrain_data;
  float:void *terrain;
    terrain_data = load_file ("dv:/users/geodata/dma/dma_0343.bin",0);
    
      /* temp stuff */
    terrain_shape = shapeof(*terrain_data);
    with (terrain_shape){
      printf("%d\n",rankof(current));
      printf("%d\n",dimof(current,0));
      printf("%d\n",dimof(current,1));
      terrain= (float:current *)
	palloc(terrain_shape,boolsizeof(float:terrain_shape));
      terrain = (float:current *)terrain_data;
      min = <?=(*terrain);
      max = >?=(*terrain);
      printf ("here....%f %f\n",min,max);
    }
    with(small_shape) {
      small= [index_0][index_1](*terrain);
      min = <?=(small);
      max = >?=(small);
      printf ("here....%f %f\n",min,max);
      for (i=0;i<5;i++) small=smooth(small);
      min = <?=(small);
      max = >?=(small);
      printf ("here....%f %f\n",min,max);
      out=CM_allocate_stack_field(16);
      CM_s_f_floor_2_2L(out,&small,16,23,8);
      if (ifd=CMFS_open
	  (filename,CMFS_O_WRONLY|CMFS_O_CREAT|CMFS_O_TRUNC,0666) < 0){
	CMFS_perror ("open failed");
	exit(1);
      }
      if (CMFS_write_file_always(ifd,out,16) != 16){
	CMFS_perror ("write failed");
	exit(1);
      }
    }
    exit(0);

    terrain_shape = shapeof(*terrain_data);
    with (terrain_shape){
      terrain= (float:current *)
	palloc(terrain_shape,boolsizeof(float:terrain_shape));
      terrain = (float:current *)terrain_data;
      for (i=0;i<20;i++) *terrain=smooth(*terrain);
      min<?=(*terrain);
      max>?=(*terrain);
      printf ("here....%f %f\n",min,max);
      out=CM_allocate_stack_field(16);
      CM_s_f_floor_2_2L(out,terrain,16,23,8);
      if (ifd=CMFS_open
	  (filename,CMFS_O_WRONLY|CMFS_O_CREAT|CMFS_O_TRUNC,0666) < 0){
	CMFS_perror ("open failed");
	exit(1);
      }
      if (CMFS_write_file_always(ifd,out,16) != 16){
	CMFS_perror ("write failed");
	exit(1);
      }
    }
  }
}
