/******************************************************************************
*                                                                             *
*  append.c - Append one DataVault file to another. Running sequence is       *
*                                                                             *
*       append in out                                                         *
*                                                                             *
*       where                                                                 *
*                                                                             *
*         in   -  Input DataVault file                                        *
*         out  -  Output DataVault file                                       *
*                                                                             *
******************************************************************************/

#include <stdio.h>
#include <string.h>
#include <cm/paris.h>
#include <cm/cm_file.h>
#include <cm/cmfs.h>
#include <cm/cm_stat.h>

void main(argc, argv)
int argc;
char **argv;
{

  char dv_in_file[128],dv_out_file[128];
  unsigned in_data, out_data;
  unsigned sa,y,n, py;
  unsigned bits_in,bits_out,ptr;
  int i,j,k,kk,move,p,bytes=1, copy=1, vc=1;
  int lines=256,channels=8,pts;
  int number_bytes =0, swap=0, flt=0;
  int steps,buffer,inner,offset;
  int dvfile_in,dvfile_out;
  int saved_channels ;
  int remux=1,depth=8;
  CM_geometry_id_t new_geometry;
  CM_geometry_id_t default_geometry;
  unsigned dimension_array[1];
  struct CM_axis_descriptor axe_desc[32];
  CM_axis_descriptor_t axe_desc_t[32];
  long transpose_size=16368;
  struct cm_stat instat,outstat;

  if (argc < 3)
    {printf("useage: reformat in_filename out_filename.\n"); exit(0);}
  strcpy(dv_in_file, argv[1]);
  strcpy(dv_out_file, argv[2]);

  CM_init();
  CM_set_safety_mode (0);

   for (i = 0; i < 2; i++) {
        axe_desc[i].weight = (1-i)*10;
        axe_desc[i].ordering = CM_send_order;
        axe_desc[i].off_chip_bits = 0;
        axe_desc[i].off_chip_pos = 0;
        axe_desc[i].on_chip_bits = 0;
        axe_desc[i].on_chip_pos = 0;
        axe_desc_t[i] = &(axe_desc[i]);
      }
 default_geometry=CM_vp_set_geometry(CM_current_vp_set);
 p=CM_geometry_send_address_length(default_geometry);
 pts=1<<p;

  axe_desc[1].length = 1;
  axe_desc[0].length = pts;
  new_geometry = CM_create_detailed_geometry((unsigned *)(&axe_desc_t[0]), 2);

  CM_set_vp_set_geometry (CM_current_vp_set,new_geometry);

  in_data=CM_allocate_stack_field(transpose_size);

  printf("opening in file...\n");
  if ((dvfile_in = CMFS_open(dv_in_file, CMFS_O_RDONLY, 0644))  == -1){
    printf("error on dv file open: %s\n", dv_in_file);
    exit(1);  }

  printf("opening out file...\n");
  if ((dvfile_out = 
         CMFS_open(dv_out_file, CMFS_O_WRONLY | CMFS_O_CREAT, 0644))  == -1){
    printf("error on out file open: %s\n", dv_out_file);
    exit(1);  }

     bits_out=CMFS_fstat(dvfile_out,&outstat);
     if (outstat.cmst_size < 0) exit(1);
     bits_out=(outstat.cmst_size/pts)*8;
     bits_out=CMFS_lseek(dvfile_out,bits_out,CMFS_L_SET);
     printf ( " offset = %d /n",bits_out); 
    bits_in=transpose_size;
    while (bits_in == transpose_size) {
    bits_in = CMFS_read_file(dvfile_in, in_data, transpose_size);
    if (bits_in == -1){CMFS_perror("Couldn't read some data"); exit(-1);}
    else printf("read %d bits of data  per vp.\n",
	      bits_in);
      bits_out = CMFS_write_file(dvfile_out, in_data,bits_in);
     }

}
