/******************************************************************************
*                                                                             *
*   CONJMULT - Multiplies element by element a vector of complex numbers      *
*              stored in a slice in CM memory by the complex conjugate of     *
*              a second slice in PE memory.                                   *
*                                                                             *
*          out    -  Pointer to the slice in CM memory  where                 *
*                    the result is to be stored                               *
*          in1    -  Pointer to first input vector slice                      *
*          in2    -  Pointer to second input vector slice                     *
*          number -  Number of complex numbers in slices                      *
*                                                                             *
******************************************************************************/

#include <cm/paris.h>


  void CONJMULT(out, in1, in2,number)
  unsigned in1,in2,out;
  unsigned number;
{
  unsigned  j ;

  for (j=0; j< number; j++) {
    CM_f_multiply_3_1L ( out+64*j, in1+64*j,in2+64*j,23,8);
    CM_f_mult_add_1L (out+64*j,in1+32+64*j,in2+32+64*j,out+64*j,23,8); 
    CM_f_multiply_3_1L (out+64*j+32,in1+32+64*j,in2+j*64,23,8);
    CM_f_mult_subf_1L ( out+64*j+32,in1+64*j,in2+j*64+32,out+64*j+32,23,8);
  }
}
