/******************************************************************************
*                                                                             *
*  COPYFREQB - Move data from input slice to output slice in CM bitreverse    *
*              the data among processing elements while moving                *
*                                                                             *
*      out    -   Slice containing output data                                *
*      in     -   Slice containing input data                                 *
*      size    -  Number of bits in input slice                               *
*      p       -  Number of bits required in PE address for bitreversal       *
*                                                                             *
******************************************************************************/

#include <cm/paris.h>
#include <math.h>

void COPYFREQB (out,in,size,p)
unsigned in,out;
int size,p;

{

  unsigned i, n, pcal, name, nameb, save_context_flag;
  unsigned temp;
  unsigned sa,x,y;
  unsigned dec= 1 << p;
  int ioff,imod;
  CM_geometry_id_t current_geometry;

  current_geometry=CM_vp_set_geometry(CM_current_vp_set);
  pcal= CM_geometry_send_address_length(current_geometry);
  n= 1 << pcal;
  save_context_flag = CM_allocate_stack_field(1);
  CM_store_context(save_context_flag);
  name = CM_allocate_stack_field(pcal);
  nameb = CM_allocate_stack_field(pcal);
  CM_u_move_zero_1L(name, pcal);
  CM_my_send_address_1L(name);
  CM_move_reversed_1L (nameb,name,pcal);
  temp=CM_allocate_stack_field(size);
  x=CM_allocate_stack_field(pcal-p);
  y=CM_allocate_stack_field(p);
  sa=CM_allocate_stack_field(pcal);

    CM_make_news_coordinate_1L ( current_geometry,sa,0,name+p,pcal-p);
    CM_u_move_constant_1L (y,0,p);
    CM_deposit_news_coordinate_1L (current_geometry,sa,1,y,p);
    CM_u_lt_constant_1L (nameb,n/dec,pcal);
    CM_logand_context_with_test();
    CM_send_1L ( temp,sa,in,size,CM_no_field);
    CM_load_context(save_context_flag);
    CM_f_move_constant_1L(out,1.,23,8);
    CM_spread_with_copy_1L(out,temp,1,size,0);
  CM_deallocate_stack_through(save_context_flag);
}


