/*

     a     - complex matrix to be decomposed
     m     - number of rows in matrix
     n     - number of columns in matrix
     s     - matrix to contain singular values
*/

#include <cm/paris.h>

  CSVD ( a,m,n,s,u,v )
  unsigned a,s,u,v;
  int m,n;

{   
  unsigned b,c,t,z,w,atemp,ctemp,qtemp,q,r;
  unsigned eps,cs,sn,f,g,h,x,y;
  unsigned ctx,ctx1,ctx2;
  float eta=1.2e-07,tol=2.4e-32,amin;
  int i,j,np,n1,k,k1,kk,l,ll,l1,iflag,jflag;
  unsigned count=0,count_split=0,count_pe;
  unsigned start[2],stop[2];
  start[0]=0;stop[0]=2047;start[1]=0;stop[1]=0;

  b=CM_allocate_stack_field(64*m);
  c=CM_allocate_stack_field(64*m);
  t=CM_allocate_stack_field(64*m);
  CM_u_move_zero_1L(b,64*m);
  CM_u_move_zero_1L(c,64*m);
  CM_u_move_zero_1L(t,64*m);
  CM_u_move_zero_1L(s,64*m);
  z=CM_allocate_stack_field(32);
  w=CM_allocate_stack_field(32);
  atemp=CM_allocate_stack_field(32);
  ctemp=CM_allocate_stack_field(64);
  qtemp=CM_allocate_stack_field(64);
  eps=CM_allocate_stack_field(32);
  q=CM_allocate_stack_field(64);
  r=CM_allocate_stack_field(64);
  count_pe=CM_allocate_stack_field(16);
  CM_u_move_zero_1L(count_pe,16);

  cs=CM_allocate_stack_field(32);
  sn=CM_allocate_stack_field(32);
  f=CM_allocate_stack_field(32);
  g=CM_allocate_stack_field(32);
  h=CM_allocate_stack_field(32);
  x=CM_allocate_stack_field(32);
  y=CM_allocate_stack_field(32);
  eps=CM_allocate_stack_field(32);

  
  ctx=CM_allocate_stack_field(1);
  ctx1=CM_allocate_stack_field(1);
  ctx2=CM_allocate_stack_field(1);

  n1=n+1;
  k=0;
  CM_u_move_zero_1L (c,23,8);

  while (k < n) {
     k1=k+1;
     CM_f_move_zero_1L(z,23,8);
     for (i=k; i<m; i++ ) {
       TAKE_AMPLITUDE_SQ(atemp,a+64*i+64*m*k);
       CM_f_add_2_1L (z,atemp,23,8);
      }
    CM_u_move_zero_1L (b+k*32,23,8);

    CM_store_context(ctx);
    CM_f_gt_constant_1L (z,tol,23,8);
    CM_logand_context_with_test();

      CM_f_sqrt_1_1L(z,23,8);
      CM_f_move_1L(b+32*k,z,23,8);
      TAKE_AMPLITUDE(w,a+64*k+64*m*k);
      CM_f_move_constant_1L ( q,1.,23,8);
      CM_f_move_zero_1L (q+32,23,8);

      CM_store_context(ctx1);
      CM_f_ne_zero_1L (w,23,8);
      CM_logand_context_with_test();
         CM_f_divide_3_1L (q,a+64*k+64*m*k,w,23,8);
         CM_f_divide_3_1L (q+32,a+64*k+64*m*k+32,w,23,8);
      CM_load_context (ctx1);
   
      CM_f_add_mult_1L (a+64*k+64*m*k,z,w,q,23,8);
      CM_f_add_mult_1L (a+64*k+64*m*k+32,z,w,q+32,23,8);
      if (k < n-1){
        for (j=k1;j<n;j++){
          CM_c_move_zero_1L (q,23,8);
          for (i=k;i<m;i++){
             CJMULT (ctemp,a+64*i+64*m*j,a+64*i+64*m*k);
             CM_c_add_2_1L (q,ctemp,23,8);
           }
       CM_f_add_mult_1L(atemp,z,w,z,23,8);
       CM_f_divide_2_1L (q,atemp,23,8);
       CM_f_divide_2_1L (q+32,atemp,23,8);

       for (i=k;i<m;i++){
          CMULT (ctemp,q,a+64*i+64*m*k);
          CM_c_subtract_2_1L (a+64*i+64*m*j,ctemp,23,8);
         }
       }
       TAKE_AMPLITUDE (atemp,a+64*k+64*m*k);
       CM_f_divide_3_1L (q,a+64*k+64*m*k,atemp,23,8);
       CM_f_divide_3_1L (q+32,a+64*k+64*m*k+32,atemp,23,8);
       CM_f_negate_1_1L (q,23,8);
       for (j=k1; j<n; j++) {
          CMULT2 (a+64*k+64*m*j,q);
        }
      }
    CM_load_context (ctx) ;
    if (k1< n) {
       CM_f_move_zero_1L(z,23,8);
       for (j=k1; j<n; j++ ) {
         TAKE_AMPLITUDE_SQ(atemp,a+64*k+64*m*j);
         CM_f_add_2_1L (z,atemp,23,8);
        }

        CM_u_move_zero_1L (c+k1*32,23,8);

        CM_store_context(ctx);
        CM_f_gt_constant_1L (z,tol,23,8);
        CM_logand_context_with_test();
           CM_f_sqrt_1_1L(z,23,8);
           CM_f_move_1L(c+32*k1,z,23,8);
           TAKE_AMPLITUDE(w,a+64*k+64*m*k1);
           CM_f_move_constant_1L ( q,1.,23,8);
           CM_f_move_zero_1L (q+32,23,8);

           CM_store_context(ctx1);
           CM_f_ne_zero_1L (w,23,8);
           CM_logand_context_with_test();
             CM_f_divide_3_1L (q,a+64*k+64*m*(k+1),w,23,8);
             CM_f_divide_3_1L (q+32,a+64*k+64*m*(k+1)+32,w,23,8);
           CM_load_context (ctx1);
           CM_f_add_mult_1L (a+64*k+64*m*(k+1),z,w,q,23,8);
           CM_f_add_mult_1L (a+64*k+64*m*(k+1)+32,z,w,q+32,23,8);

           for (i=k1;i<m;i++){
             CM_c_move_zero_1L (q,23,8);
             for (j=k1;j<n;j++){
               CJMULT (ctemp,a+64*i+64*m*j,a+64*k+64*m*j);
               CM_c_add_2_1L (q,ctemp,23,8);
              }
            CM_f_add_mult_1L(atemp,z,w,z,23,8);
            CM_f_divide_2_1L (q,atemp,23,8);
            CM_f_divide_2_1L (q+32,atemp,23,8);
            for (j=k1;j<n;j++){
              CMULT (ctemp,q,a+64*k+64*m*j);
              CM_c_subtract_2_1L (a+64*i+64*m*j,ctemp,23,8);
             }
	   }
          TAKE_AMPLITUDE (atemp,a+64*k+64*m*k1);
          CM_f_divide_3_1L (q,a+64*k+64*m*k1,atemp,23,8);
          CM_f_divide_3_1L (q+32,a+64*k+64*m*k1+32,atemp,23,8);
          CM_f_negate_1_1L (q,23,8);
          for (i=k1; i<m; i++) {
            CMULT2 (a+64*i+64*m*k1,q);
          }
     }
    CM_load_context (ctx) ;
    k=k1;
   }
  CM_load_context (ctx) ;

  CM_f_move_zero_1L(eps,23,8);
  for (k=0;k<n;k++) {
    CM_f_move_1L (s+k*32,b+k*32,23,8);
    CM_f_move_1L (t+k*32,c+k*32,23,8);
    CM_f_add_3_1L (atemp,s+k*32,t+k*32,23,8);
    CM_store_context(ctx);
    CM_f_ge_1L (atemp,eps,23,8);
    CM_logand_context_with_test();
      CM_f_move_1L (eps,atemp,23,8);
    CM_load_context (ctx) ;
  }
  CM_f_multiply_constant_2_1L (eps,eta,23,8);

  for (i=0; i<m; i++) {
    for (j=0;j< m; j++) {
      CM_f_move_zero_1L ( u+64*i+64*m*j,23,8);
      CM_f_move_zero_1L ( u+64*i+64*m*j+32,23,8);
     }
    CM_f_move_constant_1L (u+64*i+64*m*i,1.,23,8);
  }

  for (i=0; i<n; i++) {
    for (j=0;j< n; j++) {
      CM_f_move_zero_1L ( v+64*i+64*n*j,23,8);
      CM_f_move_zero_1L ( v+64*i+64*n*j+32,23,8);
     }
    CM_f_move_constant_1L (v+64*i+64*n*i,1.,23,8);
  }

  for (kk=0 ; kk<n; kk++) {
    k=n-kk-1;
    CM_load_context (ctx) ;
    CM_store_context(ctx2);
  while ( CM_global_count_context() != 0) {
    CM_load_context(ctx2);
    iflag=0;
    for ( ll=0; ll<k+1; ll++) {
         l=k-ll;
       if (iflag  == 0) {
         CM_f_abs_2_1L ( atemp,t+l*32,23,8);
         CM_f_subtract_2_1L (atemp,eps,23,8);
         amin=CM_global_f_min_1L (atemp,23,8);
         if (amin <= 0 ) {
            ll=k+1;iflag=1;
           CM_f_le_zero_1L (atemp,23,8);
           CM_logand_context_with_test();
           }
        }
       if (iflag  == 0 && l >0) {
         CM_f_abs_2_1L ( atemp,s+(l-1)*32,23,8);
         CM_f_subtract_2_1L (atemp,eps,23,8);
         amin=CM_global_f_min_1L (atemp,23,8);
         if (amin <= 0 ) {
           ll=k+1;iflag=2;
            CM_f_le_zero_1L (atemp,23,8);
            CM_logand_context_with_test();
           }
        }
     }
    if ( iflag != 1) {
      count_split++ ;
      CM_f_move_zero_1L (cs,23,8);
      CM_f_move_constant_1L (sn,1.,23,8);
      l1=l-1;
      CM_store_context (ctx1) ;
      for (i=l;i<k+1;i++) {
        CM_f_multiply_3_1L (f,sn,t+32*i,23,8);
        CM_f_multiply_2_1L (t+i*32,cs,23,8);
        CM_f_abs_2_1L (atemp,f,23,8);
        CM_f_gt_1L (atemp,eps,23,8);
        CM_logand_context_with_test();
          CM_f_move_1L (h,s+i*32,23,8);
          CM_f_multiply_3_1L (w,f,f,23,8);
          CM_f_mult_add_1L (w,h,h,w,23,8);
          CM_f_sqrt_1_1L (w,23,8);
          CM_f_move_1L (s+i*32,w,23,8);
          CM_f_divide_3_1L (cs,h,w,23,8);
          CM_f_negate_1_1L (f,23,8);
          CM_f_divide_3_1L (sn,f,w,23,8);
          for (j=0; j< n; j++) {
            printf (" l1 = %d ", l1);
            CM_f_move_1L (x,u+64*j+64*m*l1,23,8);
            CM_f_move_1L (y,u+64*j+64*m*i,23,8);
            CM_f_multiply_3_1L (u+64*j+64*m*l1,x,cs,23,8);
            CM_f_mult_add_1L (u+64*j+64*m*l1,y,sn,u+64*j+64*m*l1,23,8);
            CM_f_multiply_3_1L (u+64*j+64*m*i,y,cs,23,8);
            CM_f_mult_subf_1L (u+64*j+64*m*i,x,sn,u+64*j+64*m*i,23,8);
            CM_f_move_zero_1L (u+64*j+64*m*l1+32,23,8);
            CM_f_move_zero_1L (u+64*j+64*m*i+32,23,8);
          }
        }      
      CM_load_context (ctx1) ;
       }
      CM_f_move_1L (w,s+k*32,23,8);
      if (l != k) {
      count++;
      CM_u_add_constant_2_1L (count_pe,1,16);
      CM_f_move_1L (x,s+l*32,23,8);
      CM_f_move_1L (y,s+(k-1)*32,23,8);
      CM_f_move_1L (g,t+(k-1)*32,23,8);
      CM_f_move_1L (h,t+k*32,23,8);
      CM_f_subtract_3_1L (f,y,w,23,8);
      CM_f_add_mult_1L (f,y,w,f,23,8);
      CM_f_subtract_3_1L (atemp,g,h,23,8);
      CM_f_add_mult_1L (atemp,g,h,atemp,23,8);
      CM_f_multiply_3_1L (ctemp,h,y,23,8);
      CM_f_multiply_constant_2_1L ( ctemp,2.,23,8);
      CM_f_add_2_1L (f,atemp,23,8);
      CM_f_divide_2_1L (f,ctemp,23,8);
      CM_f_mult_add_const_1L (g,f,f,1.,23,8);
      CM_f_sqrt_1_1L (g,23,8);
      CM_store_context (ctx1) ;
      CM_f_le_zero_1L (f,23,8);
      CM_logand_context_with_test();
        CM_f_negate_1_1L (g,23,8);
      CM_load_context (ctx1) ;
      CM_f_subtract_3_1L (ctemp,x,w,23,8);
      CM_f_add_mult_1L (ctemp,x,w,ctemp,23,8);
      CM_f_add_3_1L (atemp,f,g,23,8);
      CM_f_divide_3_1L (atemp,y,atemp,23,8);
      CM_f_sub_mult_1L (atemp,atemp,h,h,23,8);
      CM_f_add_3_1L (f,ctemp,atemp,23,8);
      CM_f_divide_2_1L (f,x,23,8);

      CM_f_move_constant_1L (cs,1.,23,8);
      CM_f_move_constant_1L (sn,1.,23,8);
      l1=l+1;
      for (i=l1;i<k+1;i++) {
        CM_f_move_1L (g,t+i*32,23,8);
        CM_f_move_1L (y,s+i*32,23,8);
        CM_f_multiply_3_1L (h,sn,g,23,8);
        CM_f_multiply_2_1L (g,cs,23,8);
        CM_f_multiply_3_1L (w,f,f,23,8);
        CM_f_mult_add_1L (w,h,h,w,23,8);
        CM_f_sqrt_1_1L (w,23,8);
        CM_f_move_1L (t+(i-1)*32,w,23,8);
        CM_f_divide_3_1L (cs,f,w,23,8);
        CM_f_divide_3_1L (sn,h,w,23,8);
        CM_f_multiply_3_1L (f,x,cs,23,8);
        CM_f_mult_add_1L (f,g,sn,f,23,8);
        CM_f_multiply_3_1L (g,g,cs,23,8);
        CM_f_mult_subf_1L (g,x,sn,g,23,8);
        CM_f_multiply_3_1L (h,y,sn,23,8);
        CM_f_multiply_3_1L (y,y,cs,23,8);
          for (j=0; j< n; j++) {
            CM_f_move_1L (x,v+64*j+64*n*(i-1),23,8);
            CM_f_move_1L (w,v+64*j+64*n*i,23,8);
            CM_f_multiply_3_1L (v+64*j+64*n*(i-1),x,cs,23,8);
            CM_f_mult_add_1L (v+64*j+64*n*(i-1),w,sn,v+64*j+64*n*(i-1),23,8);
            CM_f_multiply_3_1L (v+64*j+64*n*i,w,cs,23,8);
            CM_f_mult_subf_1L (v+64*j+64*n*i,x,sn,v+64*j+64*n*i,23,8);
            CM_f_move_zero_1L (v+64*j+64*n*(i-1)+32,23,8);
            CM_f_move_zero_1L (v+64*j+64*n*i+32,23,8);
          }
        CM_f_multiply_3_1L (w,f,f,23,8);
        CM_f_mult_add_1L (w,h,h,w,23,8);
        CM_f_sqrt_1_1L (w,23,8);
        CM_f_move_1L (s+32*(i-1),w,23,8);
        CM_f_divide_3_1L (cs,f,w,23,8);
        CM_f_divide_3_1L (sn,h,w,23,8);
        CM_f_multiply_3_1L (f,g,cs,23,8);
        CM_f_mult_add_1L (f,y,sn,f,23,8);
        CM_f_multiply_3_1L (x,y,cs,23,8);
        CM_f_mult_subf_1L (x,sn,g,x,23,8);
          for (j=0; j< n; j++) {
            CM_f_move_1L (y,u+64*j+64*m*(i-1),23,8);
            CM_f_move_1L (w,u+64*j+64*m*i,23,8);
            CM_f_multiply_3_1L (u+64*j+64*m*(i-1),y,cs,23,8);
            CM_f_mult_add_1L (u+64*j+64*m*(i-1),w,sn,u+64*j+64*m*(i-1),23,8);
            CM_f_multiply_3_1L (u+64*j+64*m*i,w,cs,23,8);
            CM_f_mult_subf_1L (u+64*j+64*m*i,y,sn,u+64*j+64*m*i,23,8);
            CM_f_move_zero_1L (u+64*j+64*m*(i-1)+32,23,8);
            CM_f_move_zero_1L (u+64*j+64*m*i+32,23,8);
          }
      }
      CM_f_move_zero_1L (t+l*32,23,8);
      CM_f_move_1L (t+k*32,f,23,8);
      CM_f_move_1L (s+k*32,x,23,8);
      CM_load_context (ctx1) ;

      }
      else {
       CM_invert_context();
       CM_logand_context(ctx2);
       CM_store_context(ctx2);
       }
     }
    CM_load_context (ctx);
    CM_f_lt_zero_1L (w,23,8);
    CM_logand_context_with_test();
      CM_f_negate_2_1L (s+k*32,w,23,8);
      for (j=0; j< n; j++) {
       CM_f_negate_1_1L (v+64*j+64*n*k,23,8);
       CM_f_negate_1_1L (v+64*j+64*n*k+32,23,8);
     }
    CM_load_context (ctx) ;
    }

  for (kk=0;kk<n; kk++) {
   k=n-kk-1;
   CM_f_ne_zero_1L (b+k*32,23,8);
   CM_logand_context_with_test();
   TAKE_AMPLITUDE (atemp,a+64*k+64*m*k);
   CM_f_divide_3_1L (ctemp,a+64*k+64*m*k,atemp,23,8);
   CM_f_divide_3_1L (ctemp+32,a+64*k+64*m*k+32,atemp,23,8);
   CM_f_negate_1_1L (ctemp,23,8);
   CM_f_negate_1_1L (ctemp+32,23,8);
   for (j=0;j<m;j++) {
     CMULT2 (u+64*k+64*m*j,ctemp);
    }
   for (j=0;j<m;j++) {
    CM_u_move_zero_1L (ctemp,64);
    for (i=k;i<m;i++) {
       CJMULT (qtemp,u+64*i+64*m*j,a+64*i+64*m*k);
       CM_c_add_2_1L (ctemp,qtemp,23,8);
     }
    TAKE_AMPLITUDE (atemp,a+64*k+64*m*k);
    CM_f_multiply_2_1L (atemp,b+k*32,23,8);
    CM_f_divide_2_1L (ctemp,atemp,23,8);
    CM_f_divide_2_1L (ctemp+32,atemp,23,8);

    for (i=k;i<m;i++) {
        CMULT (qtemp,ctemp,a+64*i+64*m*k);
        CM_c_subtract_2_1L (u+64*i+64*m*j,qtemp,23,8);
      }
     }
     CM_load_context(ctx);
    }

  for (kk=1;kk<n; kk++) {
   k=n-kk-1;
   k1=k+1;
   CM_f_ne_zero_1L (c+k1*32,23,8);
   CM_logand_context_with_test();
   TAKE_AMPLITUDE (atemp,a+64*k+64*m*k1);
   CM_f_divide_3_1L (ctemp,a+64*k+64*m*k1,atemp,23,8);
   CM_f_divide_3_1L (ctemp+32,a+64*k+64*m*k1+32,atemp,23,8);
   CM_f_negate_1_1L (ctemp,23,8);
   for (j=0;j<n;j++) {
     CMULT2 (v+64*k1+64*n*j,ctemp);
    }
   for (j=0;j<n;j++) {
    CM_u_move_zero_1L (ctemp,64);
    for (i=k1;i<n;i++) {
       CMULT (qtemp,a+64*k+64*m*i,v+64*i+64*n*j);
       CM_c_add_2_1L (ctemp,qtemp,23,8);
     }
    TAKE_AMPLITUDE (atemp,a+64*k+64*m*k1);
    CM_f_multiply_2_1L (atemp,c+k1*32,23,8);
    CM_f_divide_2_1L (ctemp,atemp,23,8);
    CM_f_divide_2_1L (ctemp+32,atemp,23,8);

    for (i=k1;i<n;i++) {
       CJMULT (qtemp,ctemp,a+64*k+64*m*i);
        CM_c_subtract_2_1L (v+64*i+64*n*j,qtemp,23,8);
      }
     }
     CM_load_context(ctx);
    }

      printf (" Number of passes %d \n", count);

    CM_deallocate_stack_through(b);


} 
