#include <stdio.h>
#include <string.h>
#include <cm/paris.h>
#include <cm/cm_file.h>
#include <cm/cmfs.h>
#include <cm/cm_stat.h>

void main(argc, argv)
int argc;
char **argv;
{

  char dv_in_file[128],dv_out_file[128];
  unsigned in_data_1, in_data_2;
  unsigned sa,y,n, py;
  unsigned bits_in,bits_out,ptr;
  int i,j,k,kk,move,p,bytes=1, copy=1, vc=1;
  int lines=256,channels=8,pts;
  int number_bytes =0, swap=0, flt=0;
  int steps,buffer,inner,offset;
  int dvfile_in,dvfile_out;
  int saved_channels,vp_size=1,total ;
  int remux=1,depth=8;
  CM_vp_set_id_t p_set_id;
  CM_geometry_id_t new_geometry;
  CM_geometry_id_t default_geometry;
  unsigned dimension_array[1];
  struct CM_axis_descriptor axe_desc[32];
  CM_axis_descriptor_t axe_desc_t[32];
  long transpose_size=4096;
  unsigned vp_set_id;
  struct cm_stat instat,outstat;

  if (argc > 3)
    {printf("useage: reformat in_filename out_filename vp_size.\n"); exit(0);}
  strcpy(dv_in_file, argv[1]);
  strcpy(dv_out_file, argv[2]);

  CM_init();
  CM_set_safety_mode (1);


  printf("opening in file...\n");
  if ((dvfile_in = CMFS_open(dv_in_file, CMFS_O_RDONLY, 0644))  == -1){
    CMFS_perror("error on1 dv file open: ");
    exit(1);  }

  printf("opening out file...\n");
  if ((dvfile_out = 
         CMFS_open(dv_out_file, CMFS_O_RDONLY, 0644))  == -1){
    CMFS_perror("error on in2 file open:");
    exit(1);  }

   new_geometry=CMFS_file_geometry(dvfile_in);
   vp_set_id=CM_allocate_vp_set(new_geometry);
   CM_set_vp_set(vp_set_id);  
  in_data_1=CM_allocate_stack_field(transpose_size);
  in_data_2=CM_allocate_stack_field(transpose_size);

    CM_set_context();
    total=CM_global_count_context();
    printf (" Number of active processors %d \n", total);
    bits_in=transpose_size;
    while (bits_in == transpose_size) {
    bits_in = CMFS_read_file(dvfile_in, in_data_1, transpose_size);
    if (bits_in == -1){CMFS_perror("Couldn't read some data"); exit(-1);}
    else printf("read %d bits of data  per vp.\n",bits_in);
    bits_in = CMFS_read_file(dvfile_out, in_data_2, transpose_size);
    if (bits_in == -1){CMFS_perror("Couldn't read some data"); exit(-1);}
    else printf("read %d bits of data  per vp.\n",bits_in);
    CM_set_context();
    CM_u_eq_1L(in_data_1,in_data_2,bits_in);
    CM_logand_context_with_test();
    total=CM_global_count_context();
    printf (" Number of correct compares %d \n", total);
    CM_set_context();
}
}
