/******************************************************************************
*                                                                             *
*    REFORM - Program to reformat serial data from a fixed block size         *
*              to a larger fixed block size.                                  *
*                                                                             *
*      in_data  - Pointer to data in CM memory                                *
*      bits     - Number of bits of data per PE                               *
*      channels - Number of channels                                          *
*      remux    - Factor to increase block size                               *
*      size     - Number of bits per channel in each PE for one block of      *
*                 data from one input channel                                 *
*                                                                             *
******************************************************************************/

#include <cm/paris.h>

  REFORM (in_data,bits,channels,remux,size)
  unsigned in_data;
  int bits,channels,remux,size;

{
  unsigned temp;
  int i,j,k;

  temp=CM_allocate_stack_field (size*channels*remux);

  for (i=0;i<bits; i+= size*channels*remux) {
   for (j=0;j<remux;j++) {
    for (k=0;k<channels;k++) {
     CM_u_move_1L(temp+k*size*remux+j*size,
                   in_data+i+j*channels*size+k*size,size);
    }
   }
  CM_u_move_1L(in_data+i,temp,channels*remux*size);
  }
 
  CM_deallocate_stack_through (temp);
}
