/******************************************************************************
*                                                                             *
*  SUPPRESS does in-place spoke suppression as defined in Fred Machell's      *
*            paper, "Algorithms for Broadband Processing and Display",        *
*            ARL University of Texas, Feb 1990 section 5.2.                   *
*                                                                             *
*     rz    - Slice in CM memory containg old value and on exiting routine    *
*             has despoked value                                              *
*     y     - Slice in CM memory containg new value                           *
*     alpha - Time constant                                                   *
*                                                                             *
******************************************************************************/

#include <cm/paris.h>

  void SUPPRESS (rz, y, alpha)
  CM_memaddr_t rz, y;
  float alpha;
     
{
  unsigned bit_temp, z, az, ar;
  
  bit_temp = CM_allocate_stack_field (1);
  z = CM_allocate_stack_field (32);
  az = CM_allocate_stack_field (32);
  ar = CM_allocate_stack_field (32);
  
  CM_store_context (bit_temp);
  CM_set_context ();		
  
  CM_f_subtract_2_1L (y, rz, 23, 8);
  CM_f_mult_const_add_1L (y, y, alpha, rz, 23, 8);
  CM_f_subtract_3_1L (z, rz, y, 23, 8);
  CM_f_abs_2_1L (az, z, 23, 8);	        
  CM_f_abs_2_1L (ar, rz, 23, 8);	
  CM_f_lt_1L (az, ar, 23, 8);	        
  CM_logand_context_with_test ();
  CM_f_move_1L (rz, z, 23, 8);	        
  
  CM_load_context (bit_temp);	        
  
  CM_deallocate_stack_through (bit_temp);
}
