/*

    wrn -  Dumps to the default output device the contents of 
           a portion of CM memory.  The output format is floating
           point. Calling sequence is

       wrn ( temp, start, stop, axis ,man, exp)

   where

       temp   -  Pointer to data slice in CM memory
       start  -  Starting PE ( processing element) number
       stop   -  Ending PE number
       man    -  Number of bits per PE in the mantissa of the number
       exp    -  Number of bits per PE in the exponent of the number

*/

#include <cm/paris.h>
#include <stdio.h>

void wrn (temp,start,stop,axis,man,exp)
unsigned temp,start,stop;
int axis,man,exp;
{
   float *a;
   int rank, feo[32],cmst[32],cmend[32],cmaxis[32],fed[32];
    
   unsigned i,istep,j;

   a = (float *) calloc((stop - start) * 16, 4);
   rank = 2;
   feo[0] = feo[1] = 0;
   cmst[0] = 0;
   cmend[0] = 16;
   cmst[1] = start;
   cmend[1] = stop;
   fed[1] = stop - start;
   fed[0] = 16;
   cmaxis[0] = 0;
   cmaxis[1] = 1;
   CM_f_read_from_news_array_1L(a, feo, cmst, cmend, cmaxis, temp, man, exp,
                       rank, fed, CM_float_single);
   istep=stop - start;
    for (i = 0; i < (stop - start) * 16; i += istep) {
     for (j = 0; j < istep; j++)
       printf ("%g  ", a[i+j]);
     printf ("\n");
   }
   free(a);
 }


void wrnu (temp,start,stop,axis,len)
unsigned temp,start,stop;
int axis,len;
{
   unsigned *a;
   int rank, feo[32],cmst[32],cmend[32],cmaxis[32],fed[32];
    
   unsigned i,istep,j;

   a = (unsigned *) calloc(stop - start + 1, 4);
   rank = CM_geometry_rank(CM_vp_set_geometry(CM_current_vp_set));
   for (i = 0; i < rank; i++)
     {
       feo[i] = cmst[i] = 0;
       cmend[i] = 1;
       cmaxis[i] = i;
       fed[i] = 1;
     }
   cmst[axis] = start;
   cmend[axis] = stop;
   fed[axis] = stop - start + 1;
   CM_u_read_from_news_array_1L(a, feo, cmst, cmend, cmaxis, temp, len,
                       rank, fed, CM_32_bit);
   istep=1;
    for (i = 0; i < stop - start; i += istep) {
     for (j=0; j<istep; j++)
       printf ("%u  ", a[i+j]);
     printf (" \n");
   }
   free(a);
 }
