#include <stdio.h>
#include <cm/paris.h>
#include <cm/cmfs.h>
#include <cm/cm_file.h>

/* meter defs */
#define SCALE 1.569610e-7
#define START_X 3854.0 
#define START_Y -4671.0
#define VECTOR_X -50.0
#define VECTOR_Y 86.5

shape [8192]geo;
typedef struct { float lat,lon,alt,val; } point;
typedef struct { float x,y,z,x1,y1,z1,val; } vector;

main()
{
  int step,x,y;
  point:geo ships;
  vector:geo grid;
  int ifd;
  char *filename="dv:/users/geodata/distribution/ship_demo";
  char *filename2="dv:/users/geodata/distribution/grid_demo";
  with(geo) {
    ships.alt = -100.0;
    ships.val = -1.0;
    for(step=0;step<121;step++) {
      [step]ships.val = (float)step;
      [step]ships.lat = START_Y+step*VECTOR_Y;
      [step]ships.lon = START_X+step*VECTOR_X;
    }
    [step]ships.alt = -1500.0;
    [step]ships.val = 666.0;
    [step]ships.lat = 105.0;
    [step]ships.lon = 0.0;
    step++;
    [step]ships.alt = -1500.0;
    [step]ships.val = 666.0;
    [step]ships.lat = -90.0;
    [step]ships.lon = 0.0;

    if (ifd=CMFS_open(filename,CMFS_O_WRONLY|CMFS_O_CREAT) < 0){
      CMFS_perror ("open failed");
      exit(1);
    }
    if (CMFS_write_file(ifd,&ships,128) != 128){
      CMFS_perror ("write failed");
      exit(1);
    }
    CMFS_close(ifd);
    grid.val=0.0;
    grid.z=grid.z1=0.99;
    step=0;
    for(y=-5000;y<5001;y+=1000) {
      [step]grid.x=-5000;
      [step]grid.y=y;
      [step]grid.x1=5000;
      [step]grid.y1=y;
      [step]grid.val=1.0;
      step++;
    }
    
    for(x=-5000;x<5001;x+=1000) {
      [step]grid.x=x;
      [step]grid.y=-5000;
      [step]grid.x1=x;
      [step]grid.y1=5000;
      [step]grid.val=1.0;
      step++;
    }
    if (ifd=CMFS_open(filename2,CMFS_O_WRONLY|CMFS_O_CREAT) < 0){
      CMFS_perror ("open failed");
      exit(1);
    }
    if (CMFS_write_file(ifd,&grid,224) != 224){
      CMFS_perror ("write failed");
      exit(1);
    }
    CMFS_close(ifd);
  }
}
  
