#include "pgl_internal.h"
#include <stdio.h>
#include <cm/cmfs.h>
#include <cm/cm_file.h>


void PGL_open_dv_display(display,filename)
     PGL_display_t display;
     char *filename;
{
  unsigned dimensions[2];
  CM_vp_set_id_t entry_vp_set = CM_current_vp_set;

  dimensions[0]= PGL_next_power_two(display->width);
  dimensions[1] =PGL_next_power_two(display->height);
  display->vp_set = CM_allocate_vp_set(CM_create_geometry(dimensions,2));
  CM_set_vp_set(display->vp_set);

  if ((display->file = CMFS_open(filename,CMFS_O_CREAT|CMFS_O_WRONLY|
				 CMFS_O_TRUNC)) < 0){
    fprintf(stderr,"PGL: couldn't open display file %s.",filename);
    CMFS_perror("");
    exit(1);
  }
  CM_set_vp_set(entry_vp_set);
}


void PGL_write_dv_display(display,field,x,y)
     PGL_display_t display;
     CM_field_id_t field;
     unsigned x,y;
{
  /* cross vp move here buddy */
  if (CMFS_write_file_always (display->file,field,24)!=24){
    CMFS_perror("PGL: couldn't write display file");
    exit(1);
  }
}


void PGL_close_dv_display(display)
     PGL_display_t display;
{
  CMFS_close(display->file);
}

