#include <pgl_internal.h>

#ifdef sparc
#define PGLFW_ADD_LIGHT pglfw_add_light_
#define PGLFW_ALLOCATE_BUFFER pglfw_allocate_buffer_
#define PGLFW_ALLOCATE_DISPLAY pglfw_allocate_display_
#define PGLFW_BUFFER_AMBIENT pglfw_buffer_ambient_
#define PGLFW_CLEAR_BUFFER pglfw_clear_buffer_
#define PGLFW_CLEAR_BUFFER_TRANSFORM pglfw_clear_buffer_transform_
#define PGLFW_DISPLAY_BUFFER pglfw_display_buffer_
#define PGLFW_PLOT_SURFACE pglfw_plot_surface_
#define PGLFW_ROTATE_BUFFER pglfw_rotate_buffer_
#define PGLFW_SCALE_BUFFER pglfw_scale_buffer_
#define PGLFW_TRANSLATE_BUFFER pglfw_translate_buffer_
#endif

#if defined(sparc)
struct ftn_string {char str[256]};
#else
struct ftn_string {short len; char * str};
#endif

char *PGL_for2c_string(forstr,len)
     struct ftn_string *forstr;
     int len;
{
  int length;
  char *result;
#if defined(sparc)
  length = len-1;
#else
  length = forstr->len-1; 
#endif
  while ((length) && (forstr->str[length]==' ')) length--;
  if (length == 0) return(0);
  result=(char *)malloc(length+1);
  strncpy(result,forstr->str,length);
  result[length]=0;
  return(result);
}

void PGL_strfree(s)
     char *s;
{
  if (s) free(s);
}

void PGLFW_ADD_LIGHT(result,buffer,x,y,z,r,g,b)
     int *result;
     PGL_buffer_t *buffer;
     float *x,*y,*z;
     unsigned *r,*g,*b;
{
  *result=(int)PGL_add_light(*buffer,*x,*y,*z,*r,*g,*b);
}

void PGLFW_ALLOCATE_BUFFER (result,width,height,depth,combiner,format_string,
			    len)
     int *result;
     unsigned *width,*height,*depth,*combiner;
     char **format_string;
     int len;
{  char *temp;
  *result=(int)PGL_allocate_buffer(*width,*height,*depth,*combiner,
				   temp=PGL_for2c_string(format_string,len));
  PGL_strfree(temp);
}

void PGLFW_ALLOCATE_DISPLAY(result,type,name,width,height,len)
     int *result;
     unsigned *type;
     char **name;
     unsigned *width,*height;
     int len;
{
  char *temp;
  *result=(int)PGL_allocate_display(*type,temp=PGL_for2c_string(name,len),
				    *width,*height);
  PGL_strfree(temp);
}

void PGLFW_BUFFER_AMBIENT (buffer,r,g,b)
     PGL_buffer_t *buffer;
     unsigned *r,*g,*b;

{
  PGL_buffer_ambient(*buffer,*r,*g,*b);
}

void PGLFW_CLEAR_BUFFER(buffer)
     PGL_buffer_t *buffer;
{
  PGL_clear_buffer(*buffer);
}

void PGLFW_CLEAR_BUFFER_TRANSFORM(buffer)
     PGL_buffer_t *buffer;
{
  PGL_clear_buffer_transform(*buffer);
}

void PGLFW_DISPLAY_BUFFER(display,buffer,x,y)
     PGL_display_t *display;
     PGL_buffer_t *buffer;
     unsigned *x,*y;
{
  PGL_display_buffer(*display,*buffer,*x,*y);
}

void PGLFW_PLOT_SURFACE(dest,flags,format_string,p1,len)
     PGL_buffer_t *dest;
     unsigned *flags;
     char **format_string;
     CM_field_id_t *p1;
     int len;
{
  char *temp;
  PGL_plot_surface(*dest,*flags|PGL_fortran_geometry,
		   temp=PGL_for2c_string(format_string,len),*p1);
  PGL_strfree(temp);
}

void PGLFW_ROTATE_BUFFER(buffer,axis,value) 
     PGL_buffer_t *buffer;
     unsigned *axis;
     float *value;
{
  PGL_rotate_buffer(*buffer,*axis,*value);
}

void PGLFW_SCALE_BUFFER(buffer,axis,value) 
     PGL_buffer_t *buffer;
     unsigned *axis;
     float *value;
{
  PGL_scale_buffer(*buffer,*axis,*value);
}

void PGLFW_TRANSLATE_BUFFER(buffer,axis,value) 
     PGL_buffer_t *buffer;
     unsigned *axis;
     float *value;

{
  PGL_translate_buffer(*buffer,*axis,*value);
}

