#include "pgl_internal.h"

#define P_TYPE PGL_signed
#define P_LENGTH 32
  
void PGL_fill_line(frame)
     PGL_spawn_frame_t frame;
{
  CM_field_id_t total = CM_allocate_stack_field (P_LENGTH);
  CM_field_id_t me = CM_allocate_stack_field (P_LENGTH);
  unsigned point_length = PGL_point_length (frame->format);
  CM_field_id_t result = CM_allocate_stack_field(point_length);
  CM_field_id_t x2 = CM_add_offset_to_field_id(frame->xp,point_length);  

  
  PGL_cast (me,frame->xh,P_TYPE,PGL_signed,P_LENGTH,32);
  PGL_screen_distance (total,frame->xp,x2,P_TYPE,P_LENGTH,frame->format);
  
  switch(P_TYPE){
  case PGL_float:
    CM_f_subtract_constant_2_1L (total,1.0,S(P_LENGTH),E(P_LENGTH));
    CM_f_max_constant_2_1L (total,1.0,S(P_LENGTH),E(P_LENGTH));
    break;
  case PGL_signed:
    CM_s_subtract_constant_2_1L (total,1,P_LENGTH);
    CM_s_max_constant_2_1L (total,1,P_LENGTH);
    break;
  case PGL_unsigned:
    CM_u_subtract_constant_2_1L (total,1,P_LENGTH);
    CM_u_max_constant_2_1L (total,1,P_LENGTH);
    break;
  }
  PGL_interpolate_field (result,frame->xp,x2,frame->format,me,
			 total,P_TYPE,P_LENGTH);
  PGL_send (frame->dest,result,frame->format,frame->flags);
  CM_deallocate_stack_through (total);
}



PGL_spawn_frame_t PGL_open_line (dest,format,size,flags)
     PGL_buffer_t dest;
     PGL_format_t format;
     unsigned size;
     unsigned flags;
{
  PGL_format_t i_f=PGL_generate_transfer_format(dest,format,flags);
  unsigned point_length = PGL_point_length(i_f);
  PGL_spawn_frame_t frame;
  
  frame=PGL_open_spawn(dest,PGL_fill_line,i_f,size,2*point_length,flags);
  return(frame);
}


void PGL_write_line (frame,format,p1,p2)
     PGL_spawn_frame_t frame;
     PGL_format_t format;
     CM_field_id_t p1,p2;
{
  unsigned point_length= PGL_point_length (frame->format);
  CM_field_id_t pixels = CM_allocate_stack_field(32);
  CM_field_id_t entry_context=CM_allocate_stack_field(1);
  CM_field_id_t x1=CM_allocate_stack_field (2*point_length);
  CM_field_id_t x2=CM_add_offset_to_field_id(x1,point_length);
  
  PGL_generate_transfer_field(x1,p1,frame->dest,frame->format,format,
			      frame->flags,0);
  PGL_generate_transfer_field(x2,p2,frame->dest,frame->format,format,
			      frame->flags,0);
  CM_store_context(entry_context);
  PGL_clip_line (CM_context_flag,frame->dest,frame->format,x1,x2);
  PGL_screen_distance (pixels,x1,x2,PGL_signed,32,frame->format);
  PGL_write_spawn (frame,pixels,x1);
  CM_load_context(entry_context);
  CM_deallocate_stack_through(pixels);
}


void PGL_close_line (frame)
     PGL_spawn_frame_t frame;
{
  PGL_close_spawn(frame);
}



void PGL_plot_line(dest,flags,format_string,p1,p2)
     PGL_buffer_t dest;
     unsigned flags;
     char *format_string;
     CM_field_id_t p1,p2;
{
  PGL_format_t format=(PGL_format_t)PGL_translate_format(format_string);
  PGL_spawn_frame_t frame=(PGL_spawn_frame_t)PGL_open_line(dest,format,262144,flags);
  PGL_write_line (frame,format,p1,p2);
  PGL_close_line(frame);
}



