#include "pgl_internal.h"
#include <stdio.h>

#define P_TYPE PGL_signed
#define P_LENGTH 32

#define SP S(P_LENGTH)
#define EP E(P_LENGTH)

extern void PGL_fill_line();

void PGL_fill_quadrilateral(dest,format,source,xh)
     PGL_buffer_t dest;
     PGL_format_t format;     
     CM_field_id_t source,xh;
{
  unsigned point_length = PGL_point_length(format);
  unsigned xl = PGL_length (format,PGL_x);
  unsigned yl = PGL_length (format,PGL_y);

  unsigned xt = PGL_type (format,PGL_x);
  unsigned yt = PGL_type (format,PGL_y);

  CM_field_id_t x1=source;
  CM_field_id_t x2=CM_add_offset_to_field_id(source,point_length);
  CM_field_id_t x3=CM_add_offset_to_field_id(source,2*point_length);

  CM_field_id_t entry_context = CM_allocate_stack_field(1);
  
  CM_field_id_t total = CM_allocate_stack_field(P_LENGTH);
  CM_field_id_t ttemp = CM_allocate_stack_field(P_LENGTH);
  CM_field_id_t xytemp = CM_allocate_stack_field(P_LENGTH);
  CM_field_id_t t = CM_allocate_stack_field(P_LENGTH);
  
  CM_field_id_t r1 = CM_allocate_stack_field(2*point_length);
  CM_field_id_t r2 = CM_add_offset_to_field_id(r1,point_length);
  
  CM_field_id_t otemp = CM_allocate_stack_field(1);
  CM_field_id_t orientation = CM_allocate_stack_field(1);

  CM_field_id_t tri2 = CM_allocate_stack_field(1);

  PGL_format_t i;  

  PGL_cast (t,xh,P_TYPE,PGL_signed,P_LENGTH,32);
  CM_store_context(entry_context);

  PGL_distance (total,PGL_extract(x1,format,PGL_x),
		PGL_extract(x2,format,PGL_x),
		P_TYPE,xt,P_LENGTH,xl);
  PGL_distance (xytemp,PGL_extract(x1,format,PGL_y),
		PGL_extract(x2,format,PGL_y),
		P_TYPE,yt,P_LENGTH,yl);
  CM_u_move_constant_1L (orientation,0,1);
  PGL_gt (xytemp,total,P_TYPE,P_LENGTH);
  CM_logand_context_with_test();
  CM_u_move_1L (total,xytemp,32);
  CM_u_move_constant_1L (orientation,1,1);
  CM_load_context(entry_context);    
  

  PGL_distance (ttemp,PGL_extract(x2,format,PGL_x),
		PGL_extract(x3,format,PGL_x),
		P_TYPE,xt,P_LENGTH,xl);
  PGL_distance (xytemp,PGL_extract(x2,format,PGL_y),
		PGL_extract(x3,format,PGL_y),
		P_TYPE,yt,P_LENGTH,yl);
  CM_u_move_constant_1L (otemp,0,1);
  PGL_gt (xytemp,ttemp,P_TYPE,P_LENGTH);
  CM_logand_context_with_test();
  CM_u_move_1L (ttemp,xytemp,32);
  CM_u_move_constant_1L (otemp,1,1);
  CM_load_context(entry_context);    

  PGL_gt (ttemp,total,P_TYPE,P_LENGTH);
  CM_logand_context_with_test();
  CM_u_move_1L (total,ttemp,P_LENGTH);
  CM_swap_2_1L (x1,x3,point_length);
  CM_u_move_1L (orientation,otemp,1);
  CM_load_context(entry_context);    

  
  PGL_distance(ttemp,PGL_extract(x1,format,PGL_x),
	       PGL_extract(x3,format,PGL_x),
	       P_TYPE,xt,P_LENGTH,xl);
  PGL_distance(xytemp,PGL_extract(x1,format,PGL_y),
	       PGL_extract(x3,format,PGL_y),
		P_TYPE,yt,P_LENGTH,yl);
  CM_u_move_constant_1L (otemp,0,1);
  PGL_gt (xytemp,ttemp,P_TYPE,P_LENGTH);
  CM_logand_context_with_test();
  CM_u_move_1L (ttemp,xytemp,32);
  CM_u_move_constant_1L (otemp,1,1);
  CM_load_context(entry_context);    
  
  PGL_gt (ttemp,total,P_TYPE,P_LENGTH);
  CM_logand_context_with_test();
  CM_u_move_1L (total,ttemp,P_LENGTH);
  CM_u_move_1L (orientation,otemp,1);
  CM_swap_2_1L (x2,x3,point_length);
  CM_invert_context();
  CM_logand_context(entry_context);    
  CM_load_context(entry_context);    

  CM_load_context(orientation);
  CM_logand_context(entry_context);
  PGL_gt (PGL_extract(x1,format,PGL_y),PGL_extract(x2,format,PGL_y),yt,yl);
  CM_logand_context_with_test();
  CM_swap_2_1L (x1,x2,point_length);
  CM_load_context(orientation);
  CM_invert_context();
  CM_logand_context(entry_context);
  PGL_gt (PGL_extract(x1,format,PGL_x),PGL_extract(x2,format,PGL_x),xt,xl);
  CM_logand_context_with_test();
  CM_swap_2_1L (x1,x2,point_length);
  CM_load_context(entry_context);

  PGL_interpolate_field (r1,x1,x2,format,t,total,P_TYPE,P_LENGTH);

  CM_load_context(orientation);
  CM_logand_context(entry_context);
  PGL_gt (PGL_extract(r1,format,PGL_y),PGL_extract(x3,format,PGL_y),yt,yl);
  CM_logand_context_with_test();
  CM_store_context(tri2);
  CM_swap_2_1L (x1,x2,point_length);
  CM_load_context(orientation);
  CM_logand_context(entry_context);
  PGL_distance (ttemp,PGL_extract(x1,format,PGL_y),
		PGL_extract(x3,format,PGL_y),P_TYPE,yt,P_LENGTH,yl);

  
  CM_invert_context();
  CM_logand_context(entry_context);
  PGL_gt (PGL_extract(r1,format,PGL_x),PGL_extract(x3,format,PGL_x),xt,xl);
  CM_logand_context_with_test();
  CM_logior_always_2_1L (tri2,CM_context_flag,1);
  CM_swap_2_1L (x1,x2,point_length);
  
  CM_load_context(orientation);
  CM_invert_context();
  CM_logand_context(entry_context);
  PGL_distance (ttemp,PGL_extract(x1,format,PGL_x),
		PGL_extract(x3,format,PGL_x),P_TYPE,xt,P_LENGTH,xl);

  CM_load_context(tri2);
  switch(P_TYPE){
  case PGL_float:
    CM_f_subfrom_2_1L (t,total,S(P_LENGTH),E(P_LENGTH));
    CM_f_add_constant_2_1L (t,1.0,S(P_LENGTH),E(P_LENGTH));
    break;
  case PGL_signed:
    CM_s_subfrom_2_1L (t,total,P_LENGTH);
    CM_s_add_constant_2_1L (t,1,P_LENGTH);
    break;
  case PGL_unsigned:
    CM_u_subfrom_2_1L (t,total,P_LENGTH);
    CM_u_add_constant_2_1L (t,1,P_LENGTH);
    break;
  }

  CM_load_context(entry_context);

  PGL_interpolate_field (r2,x1,x3,format,t,ttemp,P_TYPE,P_LENGTH);
  PGL_screen_distance (total,r1,r2,PGL_signed,32,format);
  PGL_spawn (dest,total,PGL_fill_line,2*PGL_point_length(format),
	     format,r1);
  CM_deallocate_stack_through (entry_context);
}


void PGL_plot_quadrilateral_internal (dest,format,source)
     PGL_buffer_t dest;
     PGL_format_t format;
     CM_field_id_t source;
{
  unsigned point_length= PGL_point_length(format);
  CM_field_id_t entry_context = CM_allocate_stack_field(1);
  CM_field_id_t pixels = CM_allocate_stack_field(32);
  CM_field_id_t temp = CM_allocate_stack_field(32);
  CM_field_id_t x1=source;
  CM_field_id_t x2=CM_add_offset_to_field_id(source,point_length);
  CM_field_id_t x3=CM_add_offset_to_field_id(x2,point_length);
  CM_field_id_t x4=CM_add_offset_to_field_id(x3,point_length);
  
  CM_store_context(entry_context);
  CM_store_context(pixels);
  PGL_clip_line(pixels,dest,format,x1,x2);
  CM_store_context(temp);
  PGL_clip_line(temp,dest,format,x2,x3);
  CM_logior_2_1L (pixels,temp,1);
  CM_store_context(temp);
  PGL_clip_line(temp,dest,format,x3,x4);
  CM_logior_2_1L (pixels,temp,1);
  CM_store_context(temp);
  PGL_clip_line(temp,dest,format,x4,x1);
  CM_logior_2_1L (pixels,temp,1);
  CM_load_context(pixels);

  PGL_

  PGL_screen_distance (pixels,x1,x2,PGL_signed,32,format);
  PGL_screen_distance (temp,x2,x3,PGL_signed,32,format);
  CM_s_max_2_1L (pixels,temp,32);
  PGL_screen_distance (temp,x3,x1,PGL_signed,32,format);
  CM_s_max_2_1L (pixels,temp,32);
  
  
  PGL_spawn (dest,pixels,PGL_fill_quadrilateral,4*point_length,
	     format,source);
  CM_load_context(entry_context);
  CM_deallocate_stack_through(entry_context);
}


void PGL_plot_quadrilateral(dest,format_string,p1,p2,p3,p4)
     PGL_buffer_t dest;
     char *format_string;
     CM_field_id_t p1,p2,p3,p4;
{
  PGL_format_t format=(PGL_format_t)PGL_translate_format(format_string);
  PGL_format_t i_format=(PGL_format_t)
    PGL_generate_transfer_format (dest,format);
  unsigned point_length= PGL_point_length (i_format);
  CM_field_id_t args=CM_allocate_stack_field (4*point_length);
  CM_field_id_t x1=args;
  CM_field_id_t x2=CM_add_offset_to_field_id(args,point_length);
  CM_field_id_t x3=CM_add_offset_to_field_id(x2,point_length);
  CM_field_id_t x4=CM_add_offset_top_field_id(x3,point_length);
  
  PGL_generate_transfer_field(x1,p1,dest,i_format,format);
  PGL_generate_transfer_field(x2,p2,dest,i_format,format);
  PGL_generate_transfer_field(x3,p3,dest,i_format,format);
  PGL_generate_transfer_field(x4,p4,dest,i_format,format);
  PGL_plot_quadrilateral_internal (dest,format,args);
  CM_deallocate_stack_through (args);
  PGL_free_format (i_format);
  PGL_free_format (format);
}
