
#include "pgl_internal.h"


void PGL_slicewise(dest,source,format,index)
     CM_field_id_t dest,source;
     PGL_format_t format;
     unsigned index;
{
  unsigned point_length = PGL_point_length(format);
  unsigned iter = PGL_LENGTH_32 (point_length);
  CM_field_id_t temp=CM_allocate_stack_field(32);
  for (i=0;i<iter;i++){
    CM_u_move_1L (temp,source+32*i,32);
    CM_transpose32_2_1L (dest+(index*iter*32),temp,32);
  }
  CM_deallocate_stack_through (temp);
}

void PGL_fieldwise (dest,source,format,index)
     CM_field_id_t dest,source;
     PGL_format_t format;
     unsigned index;
{
  unsigned point_length = PGL_point_length(format);
  unsigned iter = PGL_LENGTH_32 (point_length);
  CM_field_id_t temp=CM_allocate_stack_field(32);
  for (i=0;i<iter;i++){
    CM_u_move_1L (temp,source+32*i,32);
    CM_transpose32_2_1L (dest+(index*iter*32),temp,32);
  }
  CM_deallocate_stack_through (temp);
}


void PGL_sort_queue (buffer)
     PGL_buffer_t buffer;
{
  CM_vp_set_id_t entry_vp_set = CM_current_vp_set;
  CM_field_id_t d1,d2,field1,field2,length,moved,index1,index2,depths,indicies;
  unsigned point_length = NEXT32(PGL_point_length(buffer->format));
  int i,total;

  CM_set_vp_set(buffer->vp_set);
  field = CM_allocate_stack_field(point_length);
  field2 = CM_allocate_stack_field(point_length);
  index = CM_allocate_stack_field(32);
  length = CM_allocate_stack_field(32);
  
  /* extract length*/
  total = CM_global_u_max_1L (length,32);
  CM_u_move_constant_always_1L (moved,1,1);

  depths = CM_allocate_stack_field (depths*total*32);
  indicies = CM_allocate_stack_field (depths*total*32);

  for (i=0;i<total;i++){
    CM_u_move_constant_1L (index,i,32);
    PGL_fieldwise (field,buffer->field,buffer->format,index);
    PGL_extract_copy (VREF(depths,i),field,format,PGL_z,PGL_float,32);
    CM_u_move_constant_1L (indicies,i,32);
  }

  /* just for now, a bubble sort*/
  while (CM_global_logior_bit(moved))
    for (i=0;i<total-1;i++){
      CM_f_gt_1L (VREF(depths,i),VREF(depths,(i+1)),23,8);
      CM_logand_context_with_test();
      CM_swap_1L (VREF(depths,i),VREF(depths,(i+1)),32);
      CM_swap_1L (VREF(indicies,i),VREF(indicies,(i+1)),32);
      CM_u_move_constant_2_1L (moved,1,1);
      CM_set_context();
    }    
  this = 0; other=1;
  PGL_fieldwise (field[this],buffer->field,buffer->format,index[which]);
  for (i=0;i<total-1;i++){
    /* get new index*/
    PGL_fieldwise (field[other],buffer->field,buffer->format,index);
    PGL_slicewise (buffer->field,field[this],buffer->format,index);
    this=(this+1)%2;
    other=(other+1)%2;    
  }
  CM_deallocate_stack_through (field);
  CM_set_vp_set(entry_vp_set);
}





