#include "pgl_internal.h"

void PGL_scan (field,format,direction)
     CM_field_id_t field;
     PGL_format_t format;
     unsigned direction;
     
{
  unsigned point_length = PGL_point_length(format);
  CM_field_id_t temp2=CM_allocate_stack_field(point_length*2+1);
  CM_field_id_t temp=CM_add_offset_to_field_id(temp2,point_length);
  CM_field_id_t total=CM_allocate_stack_field(32);
  CM_field_id_t me=CM_allocate_stack_field(32);
  CM_field_id_t depth=CM_allocate_stack_field(32);
  CM_field_id_t t1=CM_allocate_stack_field(32);
  CM_field_id_t t2=CM_allocate_stack_field(32);
  CM_field_id_t xp2=field;
  CM_field_id_t xp1=CM_add_offset_to_field_id(field,point_length);
  unsigned xl = PGL_length (format,PGL_x),zl;
  unsigned size=CM_geometry_axis_length(CM_vp_set_geometry(CM_current_vp_set),
					0);
  int i;

  if (PGL_find_name(format,PGL_z))
    zl = PGL_length (format,PGL_z);

  CM_u_move_zero_1L (me,32);
  CM_my_news_coordinate_1L (me,0,xl);
  
  CM_load_context (field+point_length*2);

  if (PGL_find_name(format,PGL_z)){
    CM_u_move_zero_always_1L (depth,zl);
    PGL_extract_copy (depth,xp1,format,PGL_z,PGL_unsigned,zl);
    depth = CM_allocate_stack_field(zl);
  }
  
  for (i=size;i>0;i--){
    CM_get_from_power_two_always_1L(temp2,xp2,0,i-1,direction,
				    2*point_length+1);
    CM_load_context (temp2+2*point_length);

    PGL_extract_copy (total,temp,format,PGL_x,PGL_signed,xl);
    CM_s_ge_1L (me,total,xl);
    CM_logand_context_with_test();
    CM_s_subfrom_2_1L (total,me,xl);
    
    PGL_extract_copy (total,temp2,format,PGL_x,PGL_signed,xl);
    CM_s_le_1L (me,total,xl);
    CM_logand_context_with_test();

    if (PGL_find_name(format,PGL_z)){
      PGL_extract_copy (t1,temp,format,PGL_x,PGL_signed,32);
      PGL_extract_copy (t2,temp2,format,PGL_x,PGL_signed,32);
      CM_s_subtract_2_1L (t2,t1,32);
      CM_s_subfrom_2_1L (t1,me,32);
      PGL_linear_interpolation(total,
			       PGL_extract(temp,format,PGL_z),
			       PGL_extract(temp2,format,PGL_z),
			       t1,t2,
			       PGL_type(format,PGL_z),PGL_signed,zl,32);
      CM_s_gt_1L (total,depth,zl);
      CM_logand_context_with_test();
      CM_u_move_1L (depth,total,zl);
    }
    CM_u_move_1L (xp2,temp2,2*point_length+1);
  }
  CM_deallocate_stack_through (temp2);
}



PGL_spawn_frame_t PGL_open_scan_line (dest,format,size,flags)
     PGL_buffer_t dest;
     PGL_format_t format;
     unsigned size;

{
  PGL_spawn_frame_t frame=(PGL_spawn_frame_t)malloc(sizeof(PGL_spawn_frame));
  CM_vp_set_id_t entry_vp_set=CM_current_vp_set;
  
  frame->size = size;
  frame->length = 0;
  frame->geometry = dest->geometry;
  frame->vp_set = dest->vp_set;
  frame->xp=CM_allocate_heap_field_vp_set(frame->size+1,frame->vp_set);
  frame->seg=CM_add_offset_to_field_id(frame->xp,frame->size);
  frame->format=format;
  frame->dest=dest;
  frame->pointer=frame->count=0;
  frame->flags=flags;

  CM_set_vp_set (frame->vp_set);
  CM_u_move_zero_always_1L (frame->xp,frame->size+1);
  CM_u_move_zero_always_1L (frame->seg,1);
  CM_set_vp_set(entry_vp_set);
  return(frame);
}


/* really fill*/
void PGL_write_scan_line (frame,points)
     PGL_spawn_frame_t frame;
     CM_field_id_t points;
{
  unsigned point_length= PGL_point_length (frame->format);
  CM_field_id_t entry_context=CM_allocate_stack_field(1);
  CM_field_id_t x1=points;
  CM_field_id_t x2=CM_add_offset_to_field_id(x1,point_length);
  CM_field_id_t address = CM_allocate_stack_field(32);
  unsigned xl=PGL_length(frame->format,PGL_x);
  unsigned yl=PGL_length(frame->format,PGL_y);
  CM_field_id_t x = CM_allocate_stack_field(xl);
  CM_field_id_t y = CM_allocate_stack_field(yl);
  CM_vp_set_id_t entry_vp_set=CM_current_vp_set;
  CM_field_id_t temp= CM_allocate_stack_field_vp_set(1,frame->vp_set);

  CM_store_context(entry_context);
  PGL_gt (PGL_extract(x2,frame->format,PGL_x),
	  PGL_extract(x1,frame->format,PGL_x),
	  PGL_type(frame->format,PGL_x),
	  PGL_length(frame->format,PGL_x));
  CM_logand_context_with_test();
  CM_swap_2_1L (x1,x2,point_length);
  
  CM_load_context(entry_context);
  
  PGL_clip_line (CM_context_flag,frame->dest,frame->format,x1,x2);
  
  PGL_extract_copy (x,x2,frame->format,PGL_x,PGL_unsigned,xl);
  PGL_extract_copy (y,x2,frame->format,PGL_y,PGL_unsigned,yl);
  CM_s_max_constant_2_1L (x,0,xl);
  CM_s_max_constant_2_1L (y,0,yl);
  CM_s_min_constant_2_1L (x,frame->dest->width-1,xl);
  CM_s_min_constant_2_1L (y,frame->dest->height-1,yl);

  CM_make_news_coordinate_1L (frame->geometry,address,0,x,xl);
  CM_deposit_news_coordinate_1L (frame->geometry,address,1,y,yl);

  CM_set_vp_set(frame->vp_set);
  CM_u_move_zero_always_1L (temp,1);
  CM_set_vp_set(entry_vp_set);
/*
  PGL_print_field(x1,frame->format);
  PGL_print_field(x2,frame->format);
*/
  CM_send_with_u_max_1L (frame->xp,address,x1,frame->size-1,temp);

  CM_set_vp_set(frame->vp_set);
  CM_logior_always_2_1L (frame->seg,temp,1);  
  CM_set_vp_set(entry_vp_set);

  CM_s_subtract_2_1L (x,PGL_extract(x1,frame->format,PGL_x),xl);
  CM_s_subtract_2_1L (y,PGL_extract(x1,frame->format,PGL_y),yl);

  CM_load_context(entry_context);
  CM_deallocate_stack_through(entry_context);
}



void PGL_close_scan_line (frame)
     PGL_spawn_frame_t frame;
{

  CM_vp_set_id_t entry_vp_set = CM_current_vp_set;
  int i,logx,xl,zl;
  unsigned point_size = PGL_point_size(frame->format);
  CM_field_id_t temp,me,total,t1,t2,depth,temp2;
  CM_field_id_t xp1=frame->xp+point_size;
  CM_field_id_t xp2=frame->xp;
  CM_field_id_t xp3=frame->xp+3*point_size+1;
  CM_field_id_t xp4=frame->xp+2*point_size+1;

  CM_set_vp_set(frame->vp_set);
  CM_set_context();
  temp2 = CM_allocate_stack_field(frame->size+1);
  temp = temp2+frame->size/2;

  me= CM_allocate_stack_field(32);
  t1 = CM_allocate_stack_field(32);
  t2 = CM_allocate_stack_field(32);
  
  PGL_scan (xp2,frame->format,CM_upwards);
  PGL_scan (xp4,frame->format,CM_downwards);
  
  CM_load_context(frame->seg);

  PGL_extract_copy (t1,xp1,frame->format,PGL_x,PGL_signed,32);
  PGL_extract_copy (t2,xp2,frame->format,PGL_x,PGL_signed,32);
  CM_s_subtract_2_1L (t2,t1,32);
  CM_s_subfrom_2_1L (t1,me,32);
  PGL_interpolate_field (xp1,xp1,xp2,frame->format,t1,t2,PGL_signed,32);
/*  
  PGL_extract_copy (t1,xp3,frame->format,PGL_x,PGL_signed,32);
  PGL_extract_copy (t2,xp4,frame->format,PGL_x,PGL_signed,32);
  CM_s_subtract_2_1L (t2,t1,32);
  CM_s_subfrom_2_1L (t1,me,32);
  PGL_interpolate_field (xp3,xp3,xp4,frame->format,t1,t2,PGL_signed,32);

  PGL_gt_2_1L (PGL_extract(xp1,frame->format,PGL_z),
	       PGL_extract(xp3,frame->format,PGL_z),
	       PGL_type (frame->format,PGL_z),
	       PGL_length (frame->format,PGL_z));
  CM_logand_context_with_test();
  CM_u_move_1L (xp1,xp3,2*point_length+1);
*/
  PGL_send (frame->dest,xp1,frame->format,frame->flags);
  CM_deallocate_heap_field(frame->xp);
  CM_deallocate_stack_through(temp2);
  free(frame);
  CM_set_context();
  CM_set_vp_set(entry_vp_set);
}


