#include "pgl_internal.h"
#include <stdio.h>
#include <math.h>

/* find black color slot from server*/
#define BACKGROUND 1
#define FOREGROUND 0
extern double drand48();

void PGL_open_x_display(display,name)
     PGL_display_t display;
     char *name;
{
  Screen *screen;
  XSetWindowAttributes my_attributes;
  XGCValues my_values;
  unsigned dimensions[2];
  
  display->mapped=0;
  display->number_of_colors = NUMBER_OF_CELLS;

  if ((display->x_display= XOpenDisplay(name)) == (Display *)0) {
    fprintf (stderr,"Can't connect with display %s",name);
  }
  
  display->x_screen = XScreenOfDisplay(display->x_display,0);

  my_attributes.backing_store=WhenMapped;
  my_attributes.background_pixel=BACKGROUND;

  display->x_window=XCreateWindow(display->x_display,
				  XRootWindow(display->x_display,0),
				  0,
				  0,
				  display->width,
				  display->height,
				  1,
				  CopyFromParent,
				  InputOutput,
				  CopyFromParent,
				  CWBackingStore|CWBackPixel,
				  &my_attributes);
  


/*				  XRootWindow(display->x_screen,0),*/
/*  display->x_window=XCreateWindow(display->x_display,
				  XRootWindowOfScreen(display->x_screen),
				  0,0,display->width,display->height,1,
				  CopyFromParent,InputOutput,
				  CopyFromParent,
				  CWBackingStore|CWBackPixel,
				  &my_attributes);
*/
  

  display->x_pixmap=XCreatePixmap (display->x_display,display->x_window,
				   display->width,display->height,
				   DefaultDepthOfScreen(display->x_screen));
  

  my_values.function = GXcopy;
  display->gc=XCreateGC(display->x_display,
			display->x_pixmap,
			GCFunction,&my_values);
  
  XSetForeground (display->x_display,display->gc,FOREGROUND);
  XSetBackground (display->x_display,display->gc,BACKGROUND);
/*
  XSetForeground (display->x_display,display->gc,BACKGROUND);
  XSetBackground (display->x_display,display->gc,BACKGROUND);
*/
  XFillRectangle (display->x_display,display->x_pixmap,display->gc,
		  0,0,display->width,display->height);
  
  display->valid_colors=0;

  if(!XAllocColorCells (display->x_display,
		    DefaultColormapOfScreen(display->x_screen),
		    0,0,0,display->translation,display->number_of_colors))
    fprintf(stderr,"PGL: error allocating %d color cells\n",
	    display->number_of_colors);

}

void PGL_set_colors (colors,num_colors,dest,source,threshold,limit,valid)
     float colors[][3];
     int num_colors;
     CM_field_id_t dest,source;
     float threshold;
     unsigned limit,valid;
{
  float error,rmin,rmax,gmin,gmax,bmin,bmax;
  float ri,gi,bi;
  int count=0,i,itr;
  CM_field_id_t entry_context = CM_allocate_stack_field(1);
  CM_field_id_t dist = CM_allocate_stack_field(32);
  CM_field_id_t temp = CM_allocate_stack_field(32);
  CM_field_id_t stored = CM_allocate_stack_field(32);
  CM_field_id_t r = CM_allocate_stack_field(32);
  CM_field_id_t g = CM_allocate_stack_field(32);
  CM_field_id_t b = CM_allocate_stack_field(32);
  
  CM_f_u_float_2_2L (r,source,8,23,8);
  CM_f_u_float_2_2L (g,CM_add_offset_to_field_id(source,8),8,23,8);
  CM_f_u_float_2_2L (b,CM_add_offset_to_field_id(source,16),8,23,8);

  rmin = CM_global_f_min_1L (r,23,8);
  rmax = CM_global_f_max_1L (r,23,8);

  gmin = CM_global_f_min_1L (g,23,8);
  gmax = CM_global_f_max_1L (g,23,8);

  bmin = CM_global_f_min_1L (b,23,8);
  bmax = CM_global_f_max_1L (b,23,8);

  if (!valid){
    i=0;
    error = pow((float)num_colors,0.3333);
    for (ri=rmin;ri<rmax;ri+=((rmax-rmin)/error))
      for (gi=gmin;gi<gmax;gi+=((gmax-gmin)/error))
	for (bi=bmin;bi<bmax;bi+=((bmax-bmin)/error))
	  if (i<num_colors){
	    colors[i][0]=ri;
	    colors[i][1]=gi;
	    colors[i][2]=bi;
	    i++;
	  }
  }

  CM_store_context(entry_context);
  itr = 0;
  error = threshold+1.0;
  while (((error > threshold) && (itr < limit)) || (itr == 0)){
    for (i=0;i<num_colors;i++){
      CM_f_subtract_constant_3_1L (temp,r,colors[i][0],23,8);
      CM_f_multiply_3_1L (dist,temp,temp,23,8);
      CM_f_subtract_constant_3_1L (temp,g,colors[i][1],23,8);
      CM_f_mult_add_1L (dist,temp,temp,dist,23,8);
      CM_f_subtract_constant_3_1L (temp,b,colors[i][2],23,8);
      CM_f_mult_add_1L (dist,temp,temp,dist,23,8);
      
      if (i>0){
	CM_f_ge_1L (stored,dist,23,8);
	CM_logand_context_with_test();
      }
      CM_u_move_1L (stored,dist,32);
      CM_u_move_constant_1L (dest,i,8);
      CM_load_context (entry_context);
    }
    
    error=0.0;
    for (i=0;i<num_colors;i++){
      CM_u_eq_constant_1L (dest,i,8);
      CM_logand_context_with_test();
      count = CM_global_count_context();
      if (count == 0){
	colors[i][0]=drand48()*(rmax-rmin)+rmin;
	colors[i][1]=drand48()*(gmax-gmin)+gmin;
	colors[i][2]=drand48()*(bmax-bmin)+bmin;
      }else {
	ri = CM_global_f_add_1L (r,23,8)/count;
	gi = CM_global_f_add_1L (g,23,8)/count;
	bi = CM_global_f_add_1L (b,23,8)/count;
	error += sqrt((colors[i][0]-ri)*(colors[i][0]-ri)+
		      (colors[i][1]-gi)*(colors[i][1]-gi)+
		      (colors[i][2]-bi)*(colors[i][2]-bi));
	colors[i][0] = ri;
	colors[i][1] = gi;
	colors[i][2] = bi;
      }
      CM_load_context (entry_context);
    }
    itr++;
  }
}


void PGL_display_X(display,screen,window,gc,buffer,wx,wy,ww,wh)
     Display *display;
     Screen screen;
     Window *window;
     GC gc;
     CM_field_id_t buffer;
     int wx,wy,ww,wh;
{
  XImage *this_image;
  unsigned char *fe_buffer;
  unsigned zero[2],end[2],axis[2],dimensions[2];
  
  CM_geometry_id_t field_geometry=CM_vp_set_geometry(CM_field_vp_set(buffer));
  unsigned field_x =CM_geometry_axis_length(field_geometry,0);
  unsigned field_y =CM_geometry_axis_length(field_geometry,1);
  
  zero[0]=zero[1]=0;
  end[0]=field_y;end[1]=field_x;
  axis[0]=1;axis[1]=0;  

  fe_buffer =(unsigned char*) malloc(field_x*field_y);
  
  CM_u_read_from_news_array_1L (fe_buffer,zero,zero,end,axis,buffer,
				8,2,end,CM_8_bit);
  
  this_image = XCreateImage (display,
			     XDefaultVisualOfScreen(screen),
			     8,ZPixmap,0,
			     fe_buffer,field_x,field_y,8,field_x);
  XPutImage (display,window,gc,this_image,0,0,wx,wy,ww,wh);
  XDestroyImage (this_image);
}


void PGL_write_x_display(display,field,x,y,buffer)
     PGL_display_t display;
     CM_field_id_t field;
     unsigned x,y;
     PGL_buffer_t buffer;
{
  CM_field_id_t xc = CM_allocate_stack_field(12);
  CM_field_id_t yc = CM_allocate_stack_field(12);
  CM_field_id_t compressed = CM_allocate_stack_field(8);
  CM_field_id_t compressed2 = CM_allocate_stack_field(9);
  XColor slot[NUMBER_OF_CELLS];
  int i;
  
  CM_store_context (compressed2+8);
  PGL_set_colors (display->colors,display->number_of_colors,
		  compressed,field,2.0,15,
		  display->valid_colors);

  for (i=0;i<display->number_of_colors;i++){
    CM_u_eq_constant_1L (compressed,i,8);
    CM_logand_context_with_test();
    CM_u_move_constant_1L (compressed2,(display->translation)[i],8);
    CM_load_context (compressed2+8);
  }

  PGL_display_X (display->x_display,display->x_screen,
		 display->x_pixmap,display->gc,
		 compressed2,x,y,buffer->width,buffer->height);

  if (!display->mapped){
    XClearWindow (display->x_display,display->x_window);
    XMapWindow(display->x_display,display->x_window);
    display->mapped++;
  }

  display->valid_colors = 1; 

  for (i=0;i<display->number_of_colors;i++){
    slot[i].flags = DoRed | DoGreen | DoBlue;
    slot[i].red = (int)(display->colors[i][0]*255.0);
    slot[i].green = (int)(display->colors[i][1]*255.0);
    slot[i].blue = (int)(display->colors[i][2]*255.0);
    slot[i].pixel= (display->translation)[i];
  }
  XStoreColors (display->x_display,
		DefaultColormapOfScreen(display->x_screen),
		slot,NUMBER_OF_CELLS);


  XCopyArea (display->x_display,
	     display->x_pixmap,
	     display->x_window,
	     display->gc,
	     0,0,
	     display->width,
	     display->height,
	     0,0);
  XFlush (display->x_display);
  CM_deallocate_stack_through(compressed);
}


void PGL_close_x_display(display)
     PGL_display_t display;
{
  /* deallocate color cells*/
  /* destroy pixmap*/
  XDestroyWindow (display->x_display,display->x_window);
  XCloseDisplay (display->x_display);
}

