typedef struct {
  float x,y,z;
} sgi_vec;

typedef struct {
  unsigned char r,g,b;
} sgi_color_t;

/* ioctl constants */
#define SGI_ROT 10             /* Rotation (vector) */
#define SGI_VIEW 15            /* Default view (sgi_view_t) */
#define SGI_ADD_VIEW 20        /* Add a view to the view list (sgi_view_t) */
#define SGI_FOV 25             /* Set the field of view (float) */
#define SGI_SET_VERTEX 30      /* Set the number of vertices (int) */
#define SGI_SEND_COLOR 35      /* Sending colors (int) */
#define SGI_SEND_NORMAL 40     /* Sending normals (int) */
#define SGI_COLOR 45           /* Set the default color (sgi_color_t) */
#define SGI_DELETE 55          /* Remove a buffer (int) */
#define SGI_DELETE_LIST 56     /* Remote multiple buffers (ints) */
#define SGI_DELETE_ALL 57      /* Remove all buffers */
#define SGI_ACTIVATE 60        /* Activate a buffer (int) */
#define SGI_ACTIVATE_LIST 61   /* Activate multiple buffers (ints) */
#define SGI_ACTIVATE_ALL 65    /* Activate all buffers */
#define SGI_DEACTIVATE 70      /* Deactivate a buffer (int) */
#define SGI_DEACTIVATE_LIST 71 /* Deactivate multiple buffers (ints) */
#define SGI_DEACTIVATE_ALL 75  /* Deactivate all buffers */
#define SGI_FRAMES 80          /* Render a number of frames (int) */
#define SGI_FRAME_BLOCK 81     /* Block until all frames rendered */
#define SGI_TRANSFER_MODE 85   /* Save data being sent? (int) */
#define SGI_ADD_LIGHT 90       /* Create a light source (sgi_light_t) */
#define SGI_LIGHT_ON 91        /* Turn light source on (int) */
#define SGI_LIGHT_OFF 92       /* Turn light source off (int) */
#define SGI_TYPE_QUAD_GRID 95  /* Data type is quad grid (int) (int) */
#define SGI_TYPE_DEFAULT   96  /* Switch back to standalone polygons */
#define SGI_DEBUG 100          /* Turn on debugging */
#define SGI_VERTEX_DEBUG 101   /* Turn on vertex debugging */
#define SGI_TMC_SUCKS 110      /* Use ethernet, not vmeio (no polygons) */
#define SGI_TRANSLATE 120      /* Translate polygons (sgi_vec_t) */
#define SGI_SCALE 130          /* Scale polygons (sgi_vec_t) */
#define SGI_RECORD_ON 140      /* Turn recording on */
#define SGI_RECORD_OFF 145     /* Turn recording off */
#define SGI_CLIP 150           /* Set the clipping plane (int) (int) */

typedef struct {
  sgi_vec lf;
  sgi_vec la;
  float twist;   /* Degrees */
} sgi_view_t;

typedef struct {
  sgi_vec ambient;
  sgi_vec lcolor;
  sgi_vec pos;
} sgi_light_t;
