#include <geodata.h>
#include <geodata_private.h>
#include <pgl/pgl.h>

static unsigned state;
static unsigned format=0;


void GS_area_open (s_dest,s_priority,memory,flags)
     unsigned s_dest;
     unsigned s_priority;     
{
  char format_string[255];
  if (format == 0){
    sprintf(format_string,"xf yf zf ru8 gu8 bu8 Tu(%d)",s_priority);
    format = PGL_translate_format (format_string);
  }
  
  state = PGL_open_surface (s_dest,format,
			    (1<<(CM_physical_cube_address_length+memory)),
			    (1<<(CM_physical_cube_address_length+1+memory)),
			    flags|PGL_generate_normals);
}


void GS_area_close()
{
  PGL_close_surface (state);
}


void GS_area_write (data,rep)
     CM_field_id_t data;
     GS_representation_t rep;
{
  CM_field_id_t temp = CM_allocate_stack_field(32);
  CM_field_id_t entry_context = CM_allocate_stack_field(1);
  GS_table_t k;
  
  CM_store_context(entry_context);
  CM_set_context();
  GS_color_value (temp,VREF(data,3),0,rep->tables,
		  rep->what_varies);
  for (k=rep->tables;k!=(GS_table_t)0;k=k->next)
    GS_color_value (temp,VREF(data,3),k,k->next,
		    rep->what_varies);
  GS_color_value (temp,VREF(data,3),0,rep->tables,
		  rep->what_varies);
  
  CM_u_move_1L (VREF(data,3),temp,32);
  CM_load_context(entry_context);
  PGL_write_surface (state,format,data);
  CM_deallocate_stack_through(temp);
}



