#include <geodata.h>
#include <geodata_private.h>
#include <pgl/pgl_internal.h>

PGL_buffer_t dest;
static unsigned state;
static unsigned priority;
static unsigned format=0;
static unsigned memory;
static unsigned fdest;

void GS_line_open (s_dest,s_priority,s_memory,flags)
     PGL_buffer_t s_dest;
     unsigned s_priority;     
     unsigned s_memory;
     unsigned flags;
{
  /*  if (format == 0)
      format = PGL_translate_format ("xf yf zf ru8 gu8 bu8");
      state = PGL_open_line (s_dest,format,262144);*/
  priority=s_priority;
  dest= s_dest;
  memory= s_memory;
  fdest=flags;
}

void GS_line_close()
{
/*  PGL_close_line(state);
*/
}


void GS_line_write (data,rep)
     CM_field_id_t data;
     GS_representation_t rep;
{
  CM_field_id_t temp = CM_allocate_stack_field(32);
  GS_table_t k;
  char format_string[80];
  float width=0.0;

  GS_color_value (temp,VREF(data,3),0,rep->tables,
		  rep->what_varies);
  for (k=rep->tables;k!=(GS_table_t)0;k=k->next){
    if (k->discrete)
      width = ((GS_line_style_t)GB_get_object(k->discrete))->width;
    GS_color_value (temp,VREF(data,3),k,k->next,rep->what_varies);
  }
  GS_color_value (temp,VREF(data,3),0,rep->tables,rep->what_varies);
/*
  if (width != 0){
    PGL_free_format(((PGL_spawn_frame_t)state)->format);
    sprintf (format_string,"xf yf zf ru8 gu8 bu8 Rs(%d)",width);
    ((PGL_spawn_frame_t)state)->format=
      (PGL_format_t)PGL_translate_format(format_string);
  }
  */
  
  if (width != 0.0)
    sprintf (format_string,"xf yf zf ru8 gu8 bu8 Rf(%f) Tu(%d)",width/2.0,
	     priority);
  else
    sprintf (format_string,"xf yf zf ru8 gu8 bu8 Tu(%d)",priority);
  
  CM_u_move_1L (VREF(data,3),temp,32);
  CM_u_move_1L (VREF(data,7),temp,32);
  PGL_plot_line (dest,fdest,format_string,data,VREF(data,4));
/*  {
    CM_vp_set_id_t entry_vp_set= CM_current_vp_set;
    CM_set_vp_set(dest->vp_set);
    PGL_print_field(dest->field,dest->format);
    CM_set_vp_set(entry_vp_set);
  }*/
  CM_deallocate_stack_through(temp);
}
