#include <geodata.h>
#include <geodata_private.h>
#include <pgl/pgl.h>

static unsigned dest;
static unsigned fdest;
static unsigned priority;
static unsigned state;
static unsigned size1;
static unsigned size2;


void GS_volume_contour_open (s_dest,s_priority,memory,flags)
     unsigned s_dest;
     unsigned s_priority;     
     unsigned memory;
     unsigned flags;
{
 dest = s_dest;
 priority=s_priority;
 size1=(1<<(CM_physical_cube_address_length+memory));
 size2=(1<<(CM_physical_cube_address_length+1+memory));
 fdest=flags|PGL_generate_normals;
}


void GS_volume_contour_close()
{

}


void GS_volume_contour_write (data,rep)
     CM_field_id_t data;
     GS_representation_t rep;
{
  GS_table_t k;
  char format[64];
  int f,frame;
  

  for (k=rep->tables;k!=(GS_table_t)0;k=k->next){
    sprintf (format,"xf yf zf vf ru(%d) gu(%d) bu(%d) Tu(%d)",
	     k->color[0],
	     k->color[1],
	     k->color[2],
	     priority);
    f = PGL_translate_format(format);
    frame = PGL_open_isosurface (dest,f,size1,size2,fdest);
    PGL_write_isosurface (frame,k->value,f,data);
    PGL_close_isosurface (frame);
  }
}

