
#include <math.h>

#define PI 3.1415927
#define EARTH_RADIUS 6371009.0
#define DEG2RAD 0.017453292

float put_in_range (number, min, max)
     float number, min, max;
{
  if (number >= max)
    while (number > max)
      number = number - (max - min);
  else
    while (number < min)
      number = number + (max - min);
  return (number);
}

main (argc, argv)
     int argc;
     char ** argv;
{
  float lat, lon, alt;
  float rlat, rlon;
  float rp, x, y, z;
  
  if (argc != 4) {
    printf ("Usage: %s <lat> <lon> <alt>\n", argv[0]);
    exit (1);
  }
  sscanf (argv[1], "%f", &lat);
  sscanf (argv[2], "%f", &lon);
  sscanf (argv[3], "%f", &alt);

  rlat = lat * DEG2RAD;
  rlon = lon * DEG2RAD;
  if ((alt >= 5.0) || (alt == 0.0))
    alt = (alt + EARTH_RADIUS) / EARTH_RADIUS;
  rp = alt * cos(rlat);
  x = -rp * cos(rlon);
  y = rp * sin(rlon);
  z = alt * sin(rlat);

  printf ("\nLat: %8.4f   Lon: %8.4f   Alt: %8.4f\n", lat, lon, alt);
  printf (" X : %8.4f    Y : %8.4f    Z : %8.4f\n\n", x, y, z);

  if (1) {
    float nlat, nlon, nalt;
    nalt = sqrt ((x*x) + (y*y) + (z*z));
    if (z == 0.0)
      rlat = 0.0;
    else
      rlat = asin (put_in_range((nalt/z), -1.0, 1.0));
    rp = nalt * cos(rlat);
    if (x == 0.0)
      if (rp >= 0.0)
	rlon = -1.0;
      else
	rlon = acos (put_in_range((-rp/x), -1.0, 1.0));
    nlat = rlat / DEG2RAD;
    nlon = rlon / DEG2RAD;
    printf ("Lat: %8.4f   Lon: %8.4f   Alt: %8.4f\n\n", nlat, nlon, nalt);
  }
}
